// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

package de.uka.ilkd.asmkey.logic;

import de.uka.ilkd.key.logic.sort.*;
import de.uka.ilkd.key.logic.Name;

/** Class with some standart sorts
 *
 * @author Stanislas Nanchen
 */

public class CollectionSort {    

    private CollectionSort() {}

    public final static Sort SEQGENERIC = ((NonCollectionSort) UniversalSort.UNIVERSAL).getSequenceSort(); 

    public final static Sort SETGENERIC = ((NonCollectionSort) UniversalSort.UNIVERSAL).getSetSort();

    public final static Sort ARRAY = 	
	ArraySortImpl.getArraySort(UniversalSort.UNIVERSAL, null, null);
}
