// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

/* Generated by Together */

/*
 * ReprModelClass represents a UML class modeled in the
 * casetool.
 *
 * Bug: Interfaces are not considered yet. (See also comment
 *      in together.TogetherReprModelClass.
 *      Consequentely, classes have only one parent.
 */


package de.uka.ilkd.key.casetool;

import java.util.Set;
import java.util.Vector;
import de.uka.ilkd.key.casetool.HashMapOfClassifier;
import de.uka.ilkd.key.proof.init.InitConfig;

public interface ReprModelClass extends ReprModel {

    String getClassName();

    String getFullClassName();


    // returns the invariant of the class if any, else ""
    String getMyInv();

    // returns the throughout of the class if any, else ""
    String getMyThroughout();

    // set the (OCL) invariant of the class
    void setMyInv(String inv);
	
    // set the GF abstract syntax for the invariant of the class
    void setMyInvGFAbs(String inv);

    // get the GF abstract syntax for the invariant of the class
    String getMyInvGFAbs();
    
    //returns the package containing this class. If there
    // is none, returns null
    String getContainingPackage();

    // return the invariant of the parent if any, else ""
    String getParentInv();
    
    // return the classname of the parent if any, else ""
    String getParentClassName();

    // returns true if class has a parent
    boolean hasOrigParent();


    // calls getOpNames on parent if any, else returns null
    Vector getParentOpNames();


    // calls getOps on parent if any, else returns null
    Vector getParentOps();


    // calls getOps on parent if any, else returns null
    // throws away ops that are constructors or not visible in
    // the subclass
    Vector getInheritedOps();

    // calls getOpNames on parent if any, else returns null
    // throws away ops that are constructors or not visible in
    // the subclass
    Vector getInheritedOpNames();

    Vector getOpNames();

    // returns ReprModelMethod
    Vector getOps();

    void getAssociations(HashMapOfClassifier 
			 classifiers);

    String getText();

    String[] getClassesInPackage();

    String getRootDirectory();

    Set getAllClasses();

}
