// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

/** @author Daniel Larsson */ 

package de.uka.ilkd.key.casetool.together.scripts.menuextension;

import de.uka.ilkd.key.casetool.ReprModelClass;
import de.uka.ilkd.key.casetool.together.TogetherOCLSimplInterface;
import java.util.LinkedList;

/** 
 * Used for OCL Simplification.
 * Simplifies the invariant of the current class by invoking
 * the prover.
 */
public class ClassMenuPoint8 extends ClassMenu {
    public String getMenuEntry(){
	return "Simplify Invariant";
    }

    protected String runCore(ReprModelClass aReprModelClass) {	    
	if (aReprModelClass.getMyInv().trim().length() > 0) {
	    LinkedList list = new LinkedList();
	    list.add(aReprModelClass.getFullClassName());
	    (new TogetherOCLSimplInterface()).simplifyConstraints(list);
	    return "";
	}
	return "No Invariant to Simplify";
    }
}
