// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

/* Generated by Together */

package de.uka.ilkd.key.casetool.together.scripts.menuextension;

import com.togethersoft.openapi.ide.window.IdeWindowManager;
import com.togethersoft.openapi.ide.IdeScript;
import com.togethersoft.openapi.rwi.*;
import com.togethersoft.openapi.rwi.enum.*;
import com.togethersoft.openapi.ide.project.*;

import java.util.Vector;
import java.io.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;

import de.uka.ilkd.key.casetool.FunctionalityOnModel;
import de.uka.ilkd.key.casetool.together.TogetherReprModelClass;
import de.uka.ilkd.key.casetool.ReprModelClass;
import de.uka.ilkd.key.ocl.OCLExport;

public class GlobalMenuPoint1_6 implements GlobalMenu{

    private Vector classes=null;
    private RwiModel rwiModel=null;
    private static File lastDirectory=null;
    private File directory;

    public String getMenuEntry(){
	return "Export all OCL specs";
    }

    
    public void run(IdeWindowManager winMan){
	classes = new Vector();
	rwiModel = RwiModelAccess.getModel();		
	// xxx instead of "$model" the constant RwiProperty.MODEL
	// should be used which however is (erroniously) labeled
	// deprecated.
	RwiPackageEnumeration rwiRoots=rwiModel.
	    rootPackages("$model");
	while (rwiRoots.hasMoreElements()) {
	    RwiPackage rwiPackage = rwiRoots.nextRwiPackage();
	    processPackage(rwiPackage);
	}
	TogetherReprModelClass[] classArray = 
	    new TogetherReprModelClass[classes.size()];
	for (int i=0; i<classArray.length; i++)
	    classArray[i] = (TogetherReprModelClass)
		(classes.elementAt(i));

	if (lastDirectory==null) {
	    IdeProject project =  IdeProjectManagerAccess.
		getProjectManager().getActiveProject();	    
	    if (project==null) {
		//no project open
		JOptionPane.showMessageDialog(new JFrame(), 
					      "No project open - "+
					      "Nothing to export!", 
					      "Error", 
					      JOptionPane.ERROR_MESSAGE);
		return;
	    }
	    String tprFile = project.getFileName();
	    String projectRoot = tprFile.substring
		(0, tprFile.lastIndexOf(File.separator));
	    directory=new File(projectRoot);
	}
	else 
	    directory=lastDirectory;
	JFileChooser jFC = new JFileChooser(directory);
	int saved = jFC.showSaveDialog(new JFrame());
	if (saved == JFileChooser.APPROVE_OPTION) {
	    String filename = jFC.getSelectedFile().getName();    
	    filename = jFC.getCurrentDirectory()+File.separator+
		(filename.endsWith(".ocl") ? filename : 
		filename+".ocl");

	    try{
		File file = new File(filename);
		FileWriter output = new FileWriter(file);
		OCLExport oclExporter = 
		    new OCLExport(classArray, output);
		oclExporter.export();
		output.close();
		lastDirectory = jFC.getCurrentDirectory();
	    } catch (IOException ioe) {
		String errorMsg = "Could not save \n"+filename+".\n";
		errorMsg += ioe.toString();	    
		JOptionPane.showMessageDialog(new JFrame(), errorMsg, "Oops...", 
					      JOptionPane.ERROR_MESSAGE);
	    }

	}	

    }

    protected void processPackage(RwiPackage rwiPackage){
	// 	findAssociations(rwiPackage);
	findClasses(rwiPackage);
	RwiPackageEnumeration subpackages = rwiPackage.subpackages();
	while (subpackages.hasMoreElements()) {
	    RwiPackage subpackage = subpackages.nextRwiPackage();
	    processPackage(subpackage);
	}
    }

    protected void findClasses(RwiPackage rwiPackage){
	RwiNodeEnumeration nodes = rwiPackage.nodes();
	while (nodes.hasMoreElements()) {
	    RwiNode aNode = nodes.nextRwiNode();
	    if (aNode.getProperty(RwiProperty.SHAPE_TYPE).
		equals(RwiShapeType.CLASS)){
		classes.addElement(new TogetherReprModelClass
		    (aNode, rwiModel, null));
	    }
	}
    }

    
}

