// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

/** @author Kristofer Johannisson */

package de.uka.ilkd.key.casetool.together.scripts.menuextension;

// import de.uka.ilkd.key.casetool.FunctionalityOnModel;
import de.uka.ilkd.key.casetool.ReprModelMethod;
import de.uka.ilkd.key.casetool.together.TogetherGFInterface;
import de.uka.ilkd.key.casetool.together.TogetherReprModelMethod;
import de.uka.ilkd.key.ocl.gf.CallbackPrePost;

public class OpMenuPoint6 extends OpMenu {
    public String getMenuEntry(){
	return "Edit Pre/Postcondition [GF]";
    }

    public String getSubMenuName(){
	return null;
    }

    protected String runCore(ReprModelMethod aReprModelMethod){
    	System.out.println("Class: " + aReprModelMethod.getContainingClassName());
		System.out.println("Signature: " + aReprModelMethod.getCallSignature());
		TogetherGFInterface tgfi = new TogetherGFInterface();
		TogetherReprModelMethod trpmm;
		try {
		        trpmm = (TogetherReprModelMethod)aReprModelMethod;
		} catch (ClassCastException e){
		        System.err.println("This shouldn't happen: " + e.getLocalizedMessage());
		        e.printStackTrace();
		        return "";
		}
        return (tgfi.editPrePost(
        	trpmm.getContainingClassName(),
        	trpmm.getContainingPackage(),
        	trpmm.getCallSignatureQualified(),
        	trpmm.getMyPreCond(),
        	trpmm.getMyPostCond(),
        	new CallbackPrePost(aReprModelMethod)));
    }
}
