// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

/** this class is saved when storing a proof. All necessary
 * field to be saved are put into this class. 
 */
package de.uka.ilkd.key.gui;

import de.uka.ilkd.key.proof.Proof;
import de.uka.ilkd.key.proof.ListOfGoal;
import de.uka.ilkd.key.logic.Namespace;

class StoreContainer implements java.io.Serializable {
    private Proof proof;
    private Namespace vars;
    private Namespace funcs;
    private Namespace sorts;
    private Namespace heuristics;
    private ListOfGoal tacletIndex;
    
    public StoreContainer(Proof proof,
			  Namespace vars, Namespace funcs,  
			  Namespace sorts, 
			  Namespace heuristics ) {
	this.proof = proof;
	this.vars = vars;
	this.funcs = funcs;
	this.sorts = sorts;
	this.heuristics = heuristics;
    }
    
    public Proof getProof() {
	return proof;
    }

    public Namespace getVariables() {
	return vars;
    }

    public Namespace getFunctions() {
	return funcs;
    }

    public Namespace getSorts() {
	return sorts;
    }

    public Namespace getHeuristics() {
	return heuristics;
    }

}
