// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
/*
 * Created on 09.09.2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
/**
 * @author koenn
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */

package de.uka.ilkd.key.gui;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import javax.swing.tree.*;
import de.uka.ilkd.key.proof.RuleTreeModel;
import de.uka.ilkd.key.logic.*;
import de.uka.ilkd.key.rule.*;
import de.uka.ilkd.key.logic.sort.Sort;
import de.uka.ilkd.key.java.Services;
import de.uka.ilkd.key.java.Recoder2KeY;
import de.uka.ilkd.key.parser.*;
import de.uka.ilkd.key.util.Debug;
import de.uka.ilkd.key.proof.mgt.Contract;
import de.uka.ilkd.key.proof.mgt.MethodContract;
import de.uka.ilkd.key.pp.NotationInfo;
import de.uka.ilkd.key.pp.LogicPrinter;
import de.uka.ilkd.key.pp.ProgramPrinter;

public class TacletView implements ActionListener{
	
	private JFrame frame;
	private JPanel textPane;
	private JTextArea content;

	private static TacletView instance = null;


	public static TacletView getInstance() {
	     if (instance == null) {
	       instance = new TacletView();
	     }
	     return instance;
   	}
   	
	private TacletView(){
        
		frame = new JFrame("Taclet View");
		frame.getContentPane().setLayout(new BorderLayout());
        
        content = new JTextArea("", 15, 30);
        content.setEditable(false);
        content.setLineWrap(true);
        content.setWrapStyleWord(true);
        
        JScrollPane scrollPane = new JScrollPane(content,
        		JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
				JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
        scrollPane.setWheelScrollingEnabled(true);
        
        TitledBorder title;
        title = BorderFactory.createTitledBorder("Taclet");
        
        textPane = new JPanel();
        textPane.add(scrollPane);  
        textPane.setBorder(title);
        //textPane.setBackground(Color.white);
        
        JButton button = new JButton("Close");
        button.addActionListener(this);
        
		JPanel buttonPane = new JPanel();
		buttonPane.add(button);
        
		frame.getContentPane().add(textPane, BorderLayout.NORTH);
		frame.getContentPane().add(buttonPane, BorderLayout.SOUTH);
        frame.pack();
       // frame.setVisible(true);
	}
	
	public void actionPerformed(ActionEvent e){
		frame.setVisible(false);
	}
	
	public void showTacletView(DefaultMutableTreeNode node){
        Taclet tac = null;
		if (node.getUserObject() instanceof Taclet) {
		    tac = (Taclet) node.getUserObject();        
        } else if (node.getUserObject() instanceof Contract) {
            tac = ((Contract)node.getUserObject()).getLemmaAndRegister();
        }
		textPane.setBorder(BorderFactory.createTitledBorder
                                                    (getDisplayName(tac)));
		content.setText(getTacletByName(tac));
		frame.setVisible(true);	
	}
	
	private String getDisplayName(Taclet tac){
		String title = "";
		title = tac.displayName();

		return title;
	}
	
	
	private String getTacletByName(Taclet tac){
		String rule = "";
		LogicPrinter lp = new LogicPrinter(new ProgramPrinter(), new NotationInfo(), true);
		lp.printTaclet(tac);
		rule = lp.toString();

		return rule;
	}
}
