// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

package de.uka.ilkd.key.java;

/**
 * represents a group of three Positions: relativePosition,
 * startPosition, endPosition
 */
public class PositionInfo implements java.io.Serializable {

    Position relPos;
    Position startPos;
    Position endPos;

    public static PositionInfo UNDEFINED=new PositionInfo();

    private PositionInfo() {
	this.relPos=Position.UNDEFINED;
	this.startPos=Position.UNDEFINED;
	this.endPos=Position.UNDEFINED;
    }

    public PositionInfo(Position relPos, Position startPos, Position endPos) {
	this.relPos=relPos;
	this.startPos=startPos;
	this.endPos=endPos;
    }

    public Position getRelativePosition() {
	return relPos;
    }

    public Position getStartPosition() {
	return startPos;
    }

    public Position getEndPosition() {
	return endPos;
    }



}
