// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//


package de.uka.ilkd.key.java.declaration;

import de.uka.ilkd.key.java.*;
import de.uka.ilkd.key.java.abstraction.*;
import de.uka.ilkd.key.java.reference.*;
import de.uka.ilkd.key.util.ExtList;
import de.uka.ilkd.key.logic.op.ProgramVariable;
import de.uka.ilkd.key.java.visitor.Visitor;

/* FieldSpecification
 * taken from COMPOST and changed to achieve an immutable structure
 */

public class ImplicitFieldSpecification extends FieldSpecification {

    /**
     *      Field specification.
     */

    public ImplicitFieldSpecification() {}

    public ImplicitFieldSpecification(ProgramVariable var) {
        this(var, var.getKeYJavaType());
    }

    /**
     *      Field specification.
     *      @param name an identifier.
     */

    public ImplicitFieldSpecification(ProgramVariable var, Type type) {
        super(var, type);
    }


    /** calls the corresponding method of a visitor in order to
     * perform some action/transformation on this element
     * @param v the Visitor
     */
    public void visit(Visitor v) {
	v.performActionOnImplicitFieldSpecification(this);
    }


}
