// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//
package de.uka.ilkd.key.logic;

import de.uka.ilkd.key.logic.op.*;
import de.uka.ilkd.key.util.Debug;
import java.util.*;

/** 
 * 
 */
class UpdateTerm extends OpTerm {

    /** 
     * creates a UpdateTerm
     * @param op the UpdateOperator
     * @param subs an array of Term
     */
    UpdateTerm(UpdateOperator op, Term[] subs) {	
	super(op, subs);
    }
 
    public JavaBlock executableJavaBlock() {
	return sub(arity()-1).javaBlock();
    }

    /** toString */
    public String toString() {
	final UpdateOperator op = (UpdateOperator) op();
	StringBuffer sb = new StringBuffer("{");
	for (int i = 0; i<op.locationCount(); i++) {
	    sb.append(op.location(this, i));
	    sb.append(":=");
	    sb.append(op.value(this, i));
	    if (i<op.locationCount()-1) {
		sb.append(", ");
	    }
	}
	sb.append("}");
	sb.append(sub(arity()-1));
	return sb.toString();
    }
}
