// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

/*
 * Generated by the KeY-Tool
 * created: APRIL 10, 2000
 */
package de.uka.ilkd.key.logic.op;

import de.uka.ilkd.key.java.Services;
import de.uka.ilkd.key.logic.sort.Sort;
import de.uka.ilkd.key.logic.Name;
import de.uka.ilkd.key.logic.Term;
import de.uka.ilkd.key.rule.MatchConditions;
import de.uka.ilkd.key.util.Debug;
public abstract class TermSymbol implements Operator {
    
    /** name of this symbol */
    private final Name name;
    
    /** sort of the term symbol
     * @link aggregation
     * @supplierCardinality 1
     * @clientCardinality * 
     */
    private final Sort sort;

    protected TermSymbol(Name name, Sort sort) {
	this.name = name;
	this.sort = sort;
    }

    /** @return Sort of the TermSymbol */
    public Sort sort(Term[] term) {
	return sort;
    }

    /** @return true iff number of subterms of term is equal to its own arity
     */
    public boolean validTopLevel(Term term){
        return term.arity()==this.arity();
    }

    /** @return name of the TermSymbol */
    public Name name() {
	return name;
    }
    
    /** @return Sort of this */ 
    public Sort sort() {
	return sort;
    }

    /**
     * @return true if the value of "term" having this operator as
     * top-level operator and may not be changed by modalities
     */
    public boolean isRigid (Term term) {
	return term.hasRigidSubterms ();
    }
    
    /** 
     * implements the default operator matching rule which means 
     * that the compared object have to be equal otherwise
     * matching fails
     */
    public MatchConditions match(Operator op, MatchConditions mc,
            Services services) {
        if (op == this) {
            return mc;
        }
        Debug.out("Operators are different(template, candidate)", this, op);
        return null;
    }
}
