package de.uka.ilkd.key.ocl.gf;                       

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import javax.swing.tree.*;
import java.io.*;
import java.util.*;

import org.apache.log4j.Logger;

public class GFEditor2 extends JFrame implements ActionListener, CaretListener,
KeyListener, FocusListener, Runnable {                        
        
        protected static Logger logger = Logger.getLogger(GFEditor2.class.getName());
        /**
         * the Thread in which the main GF reader loop is run.
         * The second thread in the game is the Swing event handler thread
         */
        private Thread selfThread; 
        private boolean isClassInv;
        private boolean isPrePost;
        private CallbackClassInv callbackClassInv;
        private CallbackPrePost callbackPrePost;
        
        /**
         * to collect the linearization strings, in the future accessible via the language
         */
        private HashMap linearizations = new HashMap();
        
        private int[] sizes = {14,18,22,26,30};
        private String[] envfonts;
        /** current Font */
        private Font font;  
        Font[] fontObjs;
        private static int DEFAULT_FONT_SIZE = 14;
        /** Dropdown list of available fonts */
        private JComboBox fontList;
        private JLabel fontLabel = new JLabel("   Font: ");
        /** Dropdown list of available font sizes */
        private JComboBox sizeList;
        private JLabel sizeLabel = new JLabel("   Size: ");
        
        public JPopupMenu popup2 = new JPopupMenu();
        /**
         * what is written here is parsed and the result inserted instead of tbe selection.
         * No idea, how this element is displayed
         */
        public JTextField parseField = new JTextField("textField!"); 
        public javax.swing.Timer timer2 = new javax.swing.Timer(500, this);
        /**
         * to save which component initiated the click to get the coordinates
         */
        public MouseEvent mouseEvent2;
        /**
         * to save the old selection before editing i field
         * or the new selection?
         */
        public String selectedText="";
        
        /** XML parsing debug messages  */
        private static boolean debugXML = false;
        /** linearization marking debug messages */
        private static boolean debugLinMarking = false;
        /** pop-up/mouse handling debug messages */
        private static boolean debugPopUp = false;
        /** red mark-up && html debug messages */
        private static boolean debugRed = false;
        /** print MarkedAreas */
        private static boolean debugMarkedAreas = false; 
        /** debug stuff for the tree */
        public static boolean debugTree = false;
        
        /**
         * selection finished of not?.
         * local
         */
        public boolean selectionCheck = false;
        /**
         * local
         */
        public LinPosition focusPosition ;
        /** 
         * stack for storing the current position:
         * When displaying, we start with the root of the AST.
         * Whenever we start to display a node, it is pushed, and when it is completely displayed, we pop it.
         * Only LinPositions are stored in here
         * local in formLin?
         * */
        public Vector currentPosition = new Vector();
        /**
         * local in outputAppend ?
         */
        public int selStart = -1;
        /**
         * local in outputAppend ?
         */
        public int selEnd = -1;
        /**
         * surely local in appendMarked
         */
        public String restString = "";
        /**
         * the length of what is already displayed of the linearization
         * local in appendMarked
         */
        public int currentLength = 0;
        /**
         * length of the portion that is to be displayed
         * local in appendMarked
         */
        public int newLength = 0;
        /**
         * length of the registered piece of text
         * local to register, only for debugging used in markedAppend
         */
        public int addedLength = 0;
        
        /**
         * When a new category is chosen, it is set to true. 
         * In the reset or a completely new state it is falsed.
         * The structure of the GF output is different then and this must be taken
         * care of.
         * The two threads communicate with this variable.
         */
        public boolean newObject = false;
        /**
         * the opposite of newObject
         * is only true, when we don't have a chosen category.
         * false: reading lins and tree
         * true: reading categories from GF
         */
        public boolean finished = false;
        /**
         * if a user sends a custom command to GF, he might want to do this again with the same command
         * Therefore it is saved.
         */
        private String parseInput = "";
        /**
         * if the user enters text for the alpha conversion, he perhaps wants to input the same text again.
         * Therefore it is saved.
         */
        private String alphaInput = "";
        /**
         * if the user enters a term, he perhaps wants to input the same text again.
         * Therefore it is saved.
         */        
        private String termInput = "";
        /**
         * default status text, just status
         */
        private final static String status = "status";
        /**
         * the language the possible actions are displayed 
         */
        private String selectedMenuLanguage = "Abstract";
        /**
         * the GF-output between <linearization> </linearization>  tags is stored here.
         * must be saved in case the displayed languages are changed.
         * Only written in readLin
         */
        private String linearization = "";
        /**
         * collects the 'greeting' text of GF, no XML, nothing of importance
         * reset in send, accumulated in the beginning of run.
         */
        private String outputString = "";
        //private String treeString = "";
        /**
         * write-only variable, stores the current import paths
         * reset after each reset.
         */
        private String fileString = "";
        /**
         * here the actual commands for the actions in the selectMenu are stored
         */
        public Vector commands = new Vector();
        /**
         * contains all the linearization pieces as MarkedArea
         * Needed to know to which node in the AST a word in the linearization 
         * area belongs
         */
        public Vector outputVector = new Vector();
        /**
         * In GF we navigate through the AST with back and forth commands.
         * When reading a from GF, we assign each tree node in the Java AST
         * the distance it has in GF from the selected node.
         * So that we can know how far we have to go.
         * The mapping between Java tree pathes and GF distances is stored 
         * in here.
         */
        public Hashtable nodeTable = new Hashtable();
        /**this FileChooser gets enriched with the Term/Text option */
        JFileChooser saveFc = new  JFileChooser("./");
        /** used for new Topic, Import and Browse (readDialog) */
        JFileChooser fc = new  JFileChooser("./");
        private final static String [] filterMenu = {"Filter", "identity", 
                        "erase", "take100", "text", "code", "latexfile", 
                        "structured", "unstructured" };
        private final static String [] modifyMenu = {"Modify", "identity","transfer", 
                        "compute", "paraphrase", "generate","typecheck", "solve", "context" };
        private static final String [] newMenu = {"New"};
        
        /**
         * in front of every other but the first language's lin
         * we put some nice asterisks
         * pointer local in formLin
         */
        private boolean firstLin = true;
        /**
         * if treeChanged is false, we don't have to rebuild it.
         * Avoids a time-consuming reconstruction and flickering.
         */
        public boolean treeChanged = true;
        /** the most common use is to store here what is read from GF */
        private String result;
        /** The output from GF is in here */
        private BufferedReader fromProc;
        /** leave messages for GF here. */
        private BufferedWriter toProc;
        /** used to print error messages */
        private final String commandPath;
        /** Linearizations' display area */
        private JTextArea linearizationArea = new JTextArea();
        /** the content of the selectMenu */
        public DefaultListModel listModel= new DefaultListModel();
        /** The list of current refinement options */
        private JList refinementList = new JList(listModel);
        /**
         * The abstract syntax tree representation of the current editing object
         */
        private DynamicTree2 tree = new DynamicTree2(this);
        
        /** Current Topic */
        private JLabel grammar = new JLabel("No topic          ");
        /**
         * Writing the current editing object to file in the term or text 
         * format
         */
        private JButton save = new JButton("Save");
        /**
         * Reading both a new environment and an editing object from file.
         * Current editing will be discarded
         */
        private JButton open = new JButton("Open");
        /**
         * Reading a new environment from file. Current editing will be 
         * discarded.
         */
        private JButton newTopic = new JButton("New Topic");
        /** Sending a command to GF */
        private JButton gfCommand = new JButton("GF command");   
        
        /** Moving the focus to the previous metavariable */
        private JButton leftMeta = new JButton("?<");
        /** Moving the focus to the previous term */
        private JButton left = new JButton("<");
        /** Moving the focus to the top term */
        private JButton top = new JButton("Top");
        /** Moving the focus to the next term */
        private JButton right = new JButton(">");
        /** Moving the focus to the next metavariable */
        private JButton rightMeta = new JButton(">?");
        /** Refining with term or linearization from typed string or file */
        private JButton read = new JButton("Read");   
        //  private JButton parse = new JButton("Parse");   
        //  private JButton term = new JButton("Term");
        /** Performing alpha-conversion of bound variables */
        private JButton alpha = new JButton("Alpha");
        /** Generating random refinement */
        private JButton random = new JButton("Random");
        /** Going back to the previous state */
        private JButton undo = new JButton("Undo");
        /** The main panel on which the others are put */
        private JPanel coverPanel = new JPanel();
        /** main area of the Read dialog (content pane)*/
        private JPanel inputPanel = new JPanel();
        /** OK, Cancel, Browse in the Read dialog */
        private JPanel inputPanel2 = new JPanel();
        /** in the Read dialog the OK button */
        private JButton ok = new JButton("OK");
        /** in the Read dialog the Cancel button */
        private JButton cancel = new JButton("Cancel");
        /** in the Read dialog the Browse button */
        private JButton browse = new JButton("Browse...");
        /** groups inputField and inputLabel */
        private JPanel inputPanel3 = new JPanel();   
        /** for 'Read' to get the input */
        private JTextField inputField = new JTextField();
        /** "Read: " */
        private JLabel inputLabel = new JLabel("Read: ");
        /** the radio group in the Read dialog to select Term or String */
        private ButtonGroup readGroup = new ButtonGroup();
        /** to select to input a Term in the Read dialog */
        private JRadioButton termReadButton = new JRadioButton("Term");
        /** to select to input a String in the Read dialog */
        private JRadioButton stringReadButton = new JRadioButton("String");
        /** the dialog to read in Strings or Terms */
        private JDialog readDialog;
        
        /**
         * The list of available categories to start editing
         */
        private JComboBox newCategoryMenu = new JComboBox(newMenu);
        /**
         * Choosing the linearization representation format
         */
        private JComboBox filter = new JComboBox(filterMenu);
        /** Choosing a linearization method */
        private JComboBox modify = new JComboBox(modifyMenu);   
        //  private JComboBox mode = new JComboBox(modeMenu);   
        /** the panel with the more general command buttons */
        private JPanel downPanel = new JPanel();
        /** the splitpane containing tree on the left and linearization area on the right*/
        private JSplitPane treePanel;
        /** the upper button bar for New, Save, Fonts */
        private JPanel upPanel = new JPanel();
        /** the panel that contains the navigation buttons and some explanatory text */
        private JPanel middlePanel = new JPanel();
        /** the panel that contains only the navigation buttons */
        private JPanel middlePanelUp = new JPanel();
        /** the panel that vontains the the explanatory text for the refinement menu */
        private JPanel middlePanelDown = new JPanel();
        /** splits between tree and lin above and nav buttons and refinements below */
        private JSplitPane centerPanel;
        /** the window that contains the refinements when in split mode */
        private JFrame gui2 = new JFrame();
        /** the main window with tree, lin and buttons when in split mode */
        private JPanel centerPanel2= new JPanel();
        /** contains refinment list and navigation buttons */
        private JPanel centerPanelDown = new JPanel();
        /** the scrollpane containing the refinements */
        private JScrollPane refinementPanel = new JScrollPane(refinementList);
        /** only contains the linearization area */
        private JScrollPane outputPanelCenter = new JScrollPane(linearizationArea);
        /** contains the linearization area and the status field below it */
        private JPanel outputPanelUp = new JPanel();
        /** contains statusLabel */
        private JPanel statusPanel = new JPanel();
        /** The type the currently focused term has */
        private JLabel statusLabel = new JLabel(status);
        //private Container cp;
        
        /** the main menu in the top */
        private JMenuBar menuBar= new JMenuBar();
        //private ButtonGroup menuGroup = new ButtonGroup();
        /** View settings */
        private JMenu viewMenu= new JMenu("View");
        /**
         * stores a list of all languages + abstract to select the language, 
         * in which the selectMenu will be filled.
         */
        private JMenu submenu= new JMenu("language");
        /** Choosing the refinement options' representation */
        private JMenu modeMenu= new JMenu("Menus");
        /** Language settings */
        private JMenu langMenu= new JMenu("Languages");
        /** Main operations */
        private JMenu fileMenu= new JMenu("File");
        /**
         * an omnipresent item, that get's overwritten several times.
         * Seems to be needed to remember for the font handling.
         * daniels has no idea yet, which radio menu is meant there
         */
        private JRadioButtonMenuItem rbMenuItem;
        /** stores whether the refinement list should be in 'long' format */
        private JRadioButtonMenuItem rbMenuItemLong;
        // private JRadioButtonMenuItem rbMenuItemAbs;
        /** stores whether the refinement list should be in 'untyped' format */
        private JRadioButtonMenuItem rbMenuItemUnTyped;
        /**
         * an omnipresent item, that get's overwritten several times.
         * Seems to be needed to remember for the font handling.
         * daniels has no idea yet, which menu is meant there
         */
        private JMenuItem fileMenuItem;
        /**
         * an omnipresent item, that get's overwritten several times.
         * Seems to be needed to remember for the font handling.
         * daniels has no idea yet, which checkbos menu is meant there
         */
        private JCheckBoxMenuItem cbMenuItem;
        /** stores whether the AST is visible or not */
        private JCheckBoxMenuItem treeCbMenuItem;
        /** the omnipresent listener that seems to handle ALL radio groups */
        private RadioListener myListener ;
        /** in the save dialog whether to save as a Term or as linearized Text */
        private ButtonGroup saveTypeGroup = new ButtonGroup();
        /** the language the menus should have */
        private ButtonGroup languageGroup = new ButtonGroup();
        
        /**
         * Initializes GF with the given command, sets up the GUI and then 
         * starts the main GF reading loop in another thread. 
         * @param gfcmd The command with all parameters, including -java
         * that is to be executed. Will set up the GF side of this session.
         */
        public GFEditor2(String gfcmd) {
                commandPath = gfcmd;
                initializeGF(gfcmd);
                initializeGUI();
                selfThread = new Thread(this);
                selfThread.start();
        }
        
        /**
         * a specialized constructor for class invariants. 
         * Starts with a new Constraint and an initial syntax tree
         * @param gfcmd The command with all parameters, including -java
         * that is to be executed. Will set up the GF side of this session.
         * @param callback The class responsible for saving the invariant 
         * as a JavaDoc comment 
         * @param initAbs the initial abstract syntax tree
         */
        public GFEditor2(String gfcmd, CallbackClassInv callback, String initAbs) {
                this.commandPath = gfcmd;
                callbackClassInv = callback;
                isClassInv = true;
                isPrePost = false;
                
                initializeGF(gfcmd);
                initializeGUI();
                selfThread = new Thread(this);
                selfThread.start();
                
//                treeChanged = true; 
//                send("n " + "Constraint");
//                newObject = true;
                
                
                // send correct term (syntax tree)
                send(initAbs);
//                treeChanged = true; // ?
//                newObject = true; // ?
                //output.setText("we would like to clear instead..."); 
                
                logger.debug("GFEditor2 constructor finished");
        }
 
        public GFEditor2(String gfcmd, CallbackPrePost callback, String initAbs) {
            this.commandPath = gfcmd;
    		callbackPrePost = callback;
    		isClassInv = false;
    		isPrePost = true;

    		initializeGF(gfcmd);
            initializeGUI();
            selfThread = new Thread(this);
            selfThread.start();
            
            // send correct term (syntax tree)
            send(initAbs);
            //output.setText("we would like to clear instead..."); 

    		logger.debug("GFEditor2 constructor finished");
       }

        /**
         * The main loop that reads all output from GF and updates the GUI
         * Nothing is sent to GF here, that is done in the Swing EHT
         */
        public void run() {
                try {
                        result = fromProc.readLine();
                        while(result != null)  {                  
                                finished = false;
                                if (debugXML) System.out.println("1 "+result);
                                while (result.indexOf("gf")==-1){                          
                                        outputString +=result+"\n";
                                        result = fromProc.readLine();
                                        if (debugXML) System.out.println("1 "+result);
                                }
                                appendMarked(outputString, -1,-1, null);
                                
                                while ((result!=null)&&(result.indexOf("newcat")==-1)&&(result.indexOf("<lin ")==-1)&&(result.indexOf("<hmsg>")==-1)){
                                        result = fromProc.readLine();
                                        if (debugXML) System.out.println("1 "+result);
                                }

                                if ((result!=null)&&(result.indexOf("<hmsg>") > -1)) {
                                        readHmsg();
                                }
                                
                                if ((result!=null)&&(result.indexOf("newcat") > -1)) {
                                        formNewMenu();
                                }
                                
                                if (!finished) { 
                                        
                                        while ((result!=null)&&((result.length()==0)||(result.indexOf("<lin ")==-1))) {
                                                result = fromProc.readLine();
                                                if (result!=null){
                                                        if (debugXML) System.out.println("10 "+result);                    
                                                } else {
                                                        System.exit(0);
                                                }
                                        }
                                        readLin();
                                        readTree();
                                        readMessage();
                                        if (newObject) {
                                                formSelectMenu();
                                        } else {
                                                while(result.indexOf("</menu")==-1) {
                                                        result = fromProc.readLine();
                                                        if (debugXML) System.out.println("12 "+result);                    
                                                }
                                        }
                                        for (int i=0; i<3; i++){ 
                                                result = fromProc.readLine();
                                                if (debugXML) System.out.println("11 "+result);                    
                                        }                                   
                                }
                        }           
                        appendMarked("*** NOTHING MORE TO READ FROM " + commandPath + "\n", -1,-1, null);
                } catch (IOException e) {
                        System.out.println("Could not read from external process");
                }
                
        }
        
        /**
         * Starts GF and sets up the reading facilities.
         * Shouldn't be called twice.
         * @param gfcmd The command for GF to be executed.
         * expects the -java parameters and all grammar modules
         * to be specified. Simply executes this command without any
         * modifications.
         */
        private void initializeGF(String gfcmd){
                try {
                        logger.debug("Trying: "+gfcmd);
                        Process extProc = Runtime.getRuntime().exec(gfcmd); 
                        InputStreamReader isr = new InputStreamReader(
                                        extProc.getInputStream(),"UTF8");
                        fromProc = new BufferedReader (isr);
                        
                        String defaultEncoding = isr.getEncoding();
                        if (debugXML) System.out.println("encoding "+defaultEncoding);
                        toProc = new BufferedWriter(new OutputStreamWriter(extProc.getOutputStream(),"UTF8"));
                } catch (IOException e) {
                        JOptionPane.showMessageDialog(new JFrame(), "Could not start " + gfcmd+
                                        "\nCheck your $PATH", "Error", 
                                        JOptionPane.ERROR_MESSAGE);
                        throw new RuntimeException("Could not start " + gfcmd+
                        "\nCheck your $PATH");
                }

        }
        
        /**
         * reliefs the constructor from setting up the GUI stuff
         */
        private void initializeGUI() {
                this.setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
                this.addWindowListener(new WindowAdapter() {
                        public void windowClosing(WindowEvent e) {
                                endProgram();
                        }
                });
                
                
                //Add listener to components that can bring up popup menus.
                MouseListener popupListener2 = new PopupListener();
                linearizationArea.addMouseListener(popupListener2);
                timer2.setRepeats(false);
                
                //now for the menus
                
                setJMenuBar(menuBar);
                setTitle("GF Syntax Editor");
                viewMenu.setToolTipText("View settings");        
                fileMenu.setToolTipText("Main operations");
                langMenu.setToolTipText("Language settings");
                menuBar.add(fileMenu);
                menuBar.add(langMenu);                        
                menuBar.add(viewMenu);
                menuBar.add(modeMenu);
                modeMenu.setToolTipText("Choosing the refinement options' representation");
                
                treeCbMenuItem = new JCheckBoxMenuItem("Tree");
                treeCbMenuItem.setActionCommand("showTree");
                myListener = new RadioListener();     
                treeCbMenuItem.addActionListener(myListener);
                treeCbMenuItem.setSelected(true);
                viewMenu.add(treeCbMenuItem);
                viewMenu.addSeparator();              
                
                fileMenuItem = new JMenuItem("Open...");
                fileMenuItem.setActionCommand("open");
                fileMenuItem.addActionListener(this);     
                fileMenu.add(fileMenuItem);
                fileMenuItem = new JMenuItem("New Topic...");
                fileMenuItem.setActionCommand("newTopic");
                fileMenuItem.addActionListener(this);     
                fileMenu.add(fileMenuItem);
                fileMenuItem = new JMenuItem("Reset");
                fileMenuItem.setActionCommand("reset");
                fileMenuItem.addActionListener(this);     
                fileMenu.add(fileMenuItem);
                fileMenuItem = new JMenuItem("Save As...");
                fileMenuItem.setActionCommand("save");
                fileMenuItem.addActionListener(this);     
                fileMenu.add(fileMenuItem);
                fileMenu.addSeparator();
                fileMenuItem = new JMenuItem("Exit");
                fileMenuItem.setActionCommand("quit");
                fileMenuItem.addActionListener(this);     
                fileMenu.add(fileMenuItem);
                
                rbMenuItem = new JRadioButtonMenuItem("One window");
                rbMenuItem.setActionCommand("combine");
                rbMenuItem.addActionListener(myListener);
                rbMenuItem.setSelected(true);
                /*        rbMenuItem.setMnemonic(KeyEvent.VK_R);
                 rbMenuItem.setAccelerator(KeyStroke.getKeyStroke(
                 KeyEvent.VK_1, ActionEvent.ALT_MASK));
                 rbMenuItem.getAccessibleContext().setAccessibleDescription(
                 "This doesn't really do anything");
                 */
                ButtonGroup menuGroup = new ButtonGroup();
                menuGroup.add(rbMenuItem);
                viewMenu.add(rbMenuItem);
                
                rbMenuItem = new JRadioButtonMenuItem("Split windows");
                rbMenuItem.setMnemonic(KeyEvent.VK_O);
                rbMenuItem.setActionCommand("split");
                rbMenuItem.addActionListener(myListener);
                menuGroup.add(rbMenuItem);
                viewMenu.add(rbMenuItem);
                
                modeMenu.add(submenu);
                
                /* rbMenuItemAbs = new JRadioButtonMenuItem("Abstract");
                 rbMenuItemAbs.setActionCommand("Abstract");
                 rbMenuItemAbs.addActionListener(myListener);
                 languageGroup.add(rbMenuItemAbs); 
                 */
                
                modeMenu.addSeparator();              
                menuGroup = new ButtonGroup();
                rbMenuItemLong = new JRadioButtonMenuItem("long");
                rbMenuItemLong.setActionCommand("long");
                rbMenuItemLong.setSelected(true);
                rbMenuItemLong.addActionListener(myListener);
                menuGroup.add(rbMenuItemLong);
                modeMenu.add(rbMenuItemLong);
                rbMenuItem = new JRadioButtonMenuItem("short");
                rbMenuItem.setActionCommand("short");
                rbMenuItem.addActionListener(myListener);
                menuGroup.add(rbMenuItem);
                modeMenu.add(rbMenuItem);
                modeMenu.addSeparator();              
                
                menuGroup = new ButtonGroup();
                rbMenuItem = new JRadioButtonMenuItem("typed");
                rbMenuItem.setActionCommand("typed");
                rbMenuItem.addActionListener(myListener);
                rbMenuItem.setSelected(false);
                menuGroup.add(rbMenuItem);
                modeMenu.add(rbMenuItem);
                rbMenuItemUnTyped = new JRadioButtonMenuItem("untyped");
                rbMenuItemUnTyped.setSelected(true);
                rbMenuItemUnTyped.setActionCommand("untyped");
                rbMenuItemUnTyped.addActionListener(myListener);
                menuGroup.add(rbMenuItemUnTyped);
                modeMenu.add(rbMenuItemUnTyped);
                
                //now for the other elements
                
                //cp = getContentPane();
                JScrollPane cpPanelScroll = new JScrollPane(coverPanel); 
                this.getContentPane().add(cpPanelScroll);
                coverPanel.setLayout(new BorderLayout());
                linearizationArea.setToolTipText("Linearizations' display area");   
                linearizationArea.addCaretListener(this);
                linearizationArea.setEditable(false);
                linearizationArea.setLineWrap(true);
                linearizationArea.setWrapStyleWord(true);
                linearizationArea.setSelectionColor(Color.green);
                //                output.setSelectionColor(Color.white);
                //                output.setFont(new Font("Arial Unicode MS", Font.PLAIN, 17));
                font = new Font(null, Font.PLAIN, DEFAULT_FONT_SIZE);
                linearizationArea.setFont(font);
                parseField.setFont(font);
                parseField.setFocusable(true);
                parseField.addKeyListener(this);
                parseField.addFocusListener(this);
                //                System.out.println(output.getFont().getFontName());
                
                //Now for the command buttons in the lower part
                gfCommand.setToolTipText("Sending a command to GF");
                read.setToolTipText("Refining with term or linearization from typed string or file");
                modify.setToolTipText("Choosing a linearization method");
                alpha.setToolTipText("Performing alpha-conversion");
                random.setToolTipText("Generating random refinement");
                undo.setToolTipText("Going back to the previous state");
                downPanel.add(gfCommand);
                downPanel.add(read);  
                downPanel.add(modify);   
                downPanel.add(alpha);     
                downPanel.add(random);
                downPanel.add(undo);
                //downPanel.add(parse);
                //downPanel.add(term);
                
                //now for the navigation buttons
                leftMeta.setToolTipText("Moving the focus to the previous metavariable");
                rightMeta.setToolTipText("Moving the focus to the next metavariable");
                left.setToolTipText("Moving the focus to the previous term");
                right.setToolTipText("Moving the focus to the next term");
                top.setToolTipText("Moving the focus to the top term");       
                middlePanelUp.add(leftMeta);
                middlePanelUp.add(left);
                middlePanelUp.add(top);
                middlePanelUp.add(right);
                middlePanelUp.add(rightMeta);
                middlePanelDown.add(new JLabel("Select Action on Subterm"));
                middlePanel.setLayout(new BorderLayout());
                middlePanel.add(middlePanelUp, BorderLayout.NORTH);
                middlePanel.add(middlePanelDown, BorderLayout.CENTER);
                
                //now for the upper button bar
                newCategoryMenu.setToolTipText("The list of available categories to start editing");
                open.setToolTipText("Reading both a new environment and an editing object from file. Current editing will be discarded");
                save.setToolTipText("Writing the current editing object to file in the term or text format");
                grammar.setToolTipText("Current Topic");
                newTopic.setToolTipText("Reading a new environment from file. Current editing will be discarded.");
                filter.setToolTipText("Choosing the linearization representation format");
                upPanel.add(grammar);
                upPanel.add(newCategoryMenu);
                upPanel.add(open);
                upPanel.add(save);
                upPanel.add(newTopic);
                upPanel.add(filter);
                
                statusLabel.setToolTipText("The current focus type");
                refinementList.setToolTipText("The list of current refinement options");
                
                //now for the font stuff
                GraphicsEnvironment gEnv = GraphicsEnvironment.getLocalGraphicsEnvironment();
                envfonts = gEnv.getAvailableFontFamilyNames();
                fontObjs = new Font[envfonts.length];
                for (int fi = 0; fi < envfonts.length; fi++) {
                        fontObjs[fi] = new Font(envfonts[fi], Font.PLAIN,
                                        DEFAULT_FONT_SIZE);
                }
                fontList = new JComboBox(envfonts);
                fontList.addActionListener(this);
                fontList.setToolTipText("Changing font type");
                
                sizeList = new JComboBox();
                sizeList.setToolTipText("Changing font size");
                for (int i = 0; i < sizes.length; i++) {
                        sizeList.addItem(new Integer(sizes[i]));
                }
                sizeList.addActionListener(this);
                
                fontEveryWhere(font);
                
                upPanel.add(sizeLabel);
                upPanel.add(sizeList);
                upPanel.add(fontLabel);
                upPanel.add(fontList);
                
                tree.setToolTipText("The abstract syntax tree representation of the current editing object");
                populateTree(tree); 
                outputPanelUp.setLayout(new BorderLayout());
                outputPanelUp.add(outputPanelCenter, BorderLayout.CENTER);
                outputPanelUp.add(statusPanel, BorderLayout.SOUTH);
                statusPanel.setLayout(new GridLayout(1,1));
                statusPanel.add(statusLabel);
                treePanel = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,
                                tree, outputPanelUp);
                treePanel.setDividerSize(5);
                treePanel.setDividerLocation(100);
                centerPanel2.setLayout(new BorderLayout());
                gui2.setSize(350,100);
                gui2.setTitle("Select Action on Subterm");
                gui2.setLocationRelativeTo(treePanel);
                centerPanelDown.setLayout(new BorderLayout());
                centerPanel = new JSplitPane(JSplitPane.VERTICAL_SPLIT,
                                treePanel, centerPanelDown);
                centerPanel.setDividerSize(5);
                centerPanel.setDividerLocation(250);
                centerPanel.addKeyListener(tree);      
                centerPanel.setOneTouchExpandable(true);
                centerPanelDown.add(middlePanel, BorderLayout.NORTH);
                centerPanelDown.add(refinementPanel, BorderLayout.CENTER);
                coverPanel.add(centerPanel, BorderLayout.CENTER);
                coverPanel.add(upPanel, BorderLayout.NORTH);
                coverPanel.add(downPanel, BorderLayout.SOUTH);
                
                refinementList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
                
                MouseListener mouseListener = new MouseAdapter() {
                        public void mouseClicked(MouseEvent e) {
                                if (e.getClickCount() == 2) {
                                        listAction(refinementList.locationToIndex(e.getPoint()));
                                }
                        }
                };
                refinementList.addMouseListener(mouseListener);
                refinementList.addKeyListener(this);
                newCategoryMenu.addActionListener(this);
                save.addActionListener(this);     
                open.addActionListener(this);     
                newTopic.addActionListener(this);
                gfCommand.addActionListener(this);     
                
                filter.addActionListener(this);   
                filter.setMaximumRowCount(9);  
                leftMeta.addActionListener(this);     
                left.addActionListener(this);
                
                newCategoryMenu.setFocusable(false);
                save.setFocusable(false); 
                save.setActionCommand("save");
                open.setFocusable(false); 
                open.setActionCommand("open");
                newTopic.setFocusable(false);
                newTopic.setActionCommand("newTopic");
                gfCommand.setFocusable(false);
                
                filter.setFocusable(false);
                leftMeta.setFocusable(false);
                left.setFocusable(false);  
                
                top.addActionListener(this);     
                right.addActionListener(this);     
                rightMeta.addActionListener(this);     
                //parse.addActionListener(this);     
                //term.addActionListener(this);     
                read.addActionListener(this);     
                modify.addActionListener(this);     
                //mode.addActionListener(this);     
                alpha.addActionListener(this);     
                random.addActionListener(this);     
                undo.addActionListener(this);
                
                top.setFocusable(false);  
                right.setFocusable(false);  
                rightMeta.setFocusable(false);  
                //parse.setFocusable(false);  
                //term.setFocusable(false);  
                read.setFocusable(false);  
                modify.setFocusable(false);  
                //mode.setFocusable(false);  
                alpha.setFocusable(false);  
                random.setFocusable(false);  
                undo.setFocusable(false);  
                
                linearizationArea.addKeyListener(tree);            
                this.setSize(800,600);
                outputPanelUp.setPreferredSize(new Dimension(400,230));
                treePanel.setDividerLocation(0.3);
                nodeTable.put(new TreePath(DynamicTree2.rootNode.getPath()), new Integer(0));
                setVisible(true);
                
                JRadioButton termButton = new JRadioButton("Term");
                termButton.setActionCommand("term");
                termButton.setSelected(true);  
                JRadioButton linButton = new JRadioButton("Text");
                linButton.setActionCommand("lin");
                // Group the radio buttons.
                saveTypeGroup.add(linButton);
                saveTypeGroup.add(termButton);
                JPanel buttonPanel = new JPanel();
                buttonPanel.setPreferredSize(new Dimension(70, 70));
                buttonPanel.add(new JLabel("Format:"));
                buttonPanel.add(linButton);
                buttonPanel.add(termButton);
                saveFc.setAccessory(buttonPanel);
                
                termReadButton.setActionCommand("term");
                stringReadButton.setSelected(true);  
                stringReadButton.setActionCommand("lin");
                // Group the radio buttons.
                readGroup.add(stringReadButton);
                readGroup.add(termReadButton);
                JPanel readButtonPanel = new JPanel();
                readButtonPanel.setLayout(new GridLayout(3,1));
                readButtonPanel.setPreferredSize(new Dimension(70, 70));
                readButtonPanel.add(new JLabel("Format:"));
                readButtonPanel.add(stringReadButton);
                readButtonPanel.add(termReadButton);
                readDialog= new JDialog(this, "Input");
                readDialog.setLocationRelativeTo(this);
                readDialog.getContentPane().add(inputPanel);
                inputPanel.setLayout(new BorderLayout(10,10));
                inputPanel3.setLayout(new GridLayout(2,1,5,5));
                inputPanel3.add(inputLabel);
                inputPanel3.add(inputField);
                ok.addActionListener(this);
                browse.addActionListener(this);
                cancel.addActionListener(this);
                inputField.setPreferredSize(new Dimension(300,23));
                inputPanel.add(inputPanel3, BorderLayout.CENTER);
                inputPanel.add(new JLabel(" "), BorderLayout.WEST);
                inputPanel.add(readButtonPanel, BorderLayout.EAST);
                inputPanel.add(inputPanel2, BorderLayout.SOUTH);
                inputPanel2.add(ok);
                inputPanel2.add(cancel);
                inputPanel2.add(browse);
                readDialog.setSize(640,135);
                
        }
        
        /**
         * send a command to GF
         * @param the command, exacltly the string that is going to be sent
         */
        protected void send(String text){
                if (logger.isDebugEnabled()) {
                        logger.debug("## send: '" + text + "'");
                }
                try {
                        linearizationArea.setText("");
                        outputString = ""; 
                        if (debugXML) 
                                System.out.println("output cleared\n\n\n");     
                        outputVector = new Vector();         
                        toProc.write(text, 0, text.length());
                        toProc.newLine();
                        toProc.flush();
                } catch (IOException e) {
                        System.out.println("Could not write to external process");
                }  
        }            
        
        public static void main(String args[])
        { 
                Locale.setDefault(Locale.US);
                GFEditor2 gui = new GFEditor2(args[0]);
                if (logger.isDebugEnabled()) {
                        logger.debug("main finished");
                }
        }

        /**
         * Calls the Java GF GUI to edit an invariant
         * @param gfCmd the command to start the GF, must include the -java and all modules
         * @param callback the callback class that knows how to store the constraints
         * @param initAbs the initial abstract syntax tree (not OCL)
         * @param initDefault if initAbs is empty, then initDefault is used
         */
        public static void mainClassInv(String gfCmd, CallbackClassInv callback, String initAbs, String initDefault) {
                Locale.setDefault(Locale.US);
                GFEditor2 gui;
                //gui = new GFEditor2(gfCmd, callback, "");

                if (initAbs.equals("")) {
                        gui = new GFEditor2(gfCmd, callback, "[ctn] g " + initDefault);
                } else {
                        gui = new GFEditor2(gfCmd, callback, "[ctn] g " + initAbs);
                }
                        
        }
        
        public static void mainPrePost(String gfPath, CallbackPrePost callback, String initAbs, String initDefault) {
                Locale.setDefault(Locale.US);
                GFEditor2 gui;
                if (initAbs.equals("")) {
                        gui = new GFEditor2(gfPath, callback, "[ctn] g " + initDefault);
                } else {
                        gui = new GFEditor2(gfPath, callback, "[ctn] g " + initAbs);
                }
        }        
        
        /** we should not end the program, just close the GF editor
         * possibly sending something back to KeY */
        protected void endProgram(){
                int returnStatus = JOptionPane.showConfirmDialog(this, "Save constraint?", "Save before quitting?", JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE  );
                if (returnStatus == JOptionPane.CANCEL_OPTION) {
                        return;
                }
                try {  
                        // quit should always work even if we cannot send something proper
                        // back to Together/KeY.
                        // Hence this try-catch
                        if (returnStatus == JOptionPane.YES_OPTION) {
                                String ocl = (String)linearizations.get(GFinterface.modelModulName + "OCL");
                                if (ocl == null) {
                                        //admit defeat:
                                        System.err.println("ERROR: OCL linearization switched off!");
                                        return;
                                } else {
                                        ocl = compactSpaces(ocl.trim()).trim();
                                }
                                String eng = (String)linearizations.get(GFinterface.modelModulName + "Eng");
                                if (eng != null) {
                                        eng = eng.trim();
                                }
                                String ger = (String)linearizations.get(GFinterface.modelModulName + "Ger");
                                if (ger != null) {
                                        eng = eng.trim();
                                }
                                
                                if (isClassInv) { // send linearization as a class invariant
                                        int invStart = ocl.indexOf("inv:") + 4;
                                        callbackClassInv.sendInvariant(ocl.substring(invStart), eng, ger);
                                } else if (isPrePost) { // send lin. as pre-/postconditions
                                        // assumption: ocl constraint has form ... .. pre: .... ... post: ...
                                        
                                        int postEnd = ocl.length();
                                        int postStart = ocl.lastIndexOf("post:") + 5;
                                        int preEnd = postStart - 5;
                                        int preStart = ocl.lastIndexOf("pre:", preEnd) + 4;
                                        String preCond = ocl.substring(preStart, preEnd).trim();
                                        String postCond = ocl.substring(postStart, postEnd).trim();
                                        callbackPrePost.sendPrePost(compactSpaces(preCond.trim()), compactSpaces(postCond.trim()));
                                        
                                }
                        }
                } catch (Exception e) { // just print information about the exception
                        System.err.println("GFEditor2.endProgram() Caught an Exception.");
                        System.err.println(
                                        "e.getMessage(): " + e.getMessage());
                        System.err.println(
                                        "e.getLocalizedMessage(): " +
                                        e.getLocalizedMessage());
                        System.err.println("e.toString(): " + e);
                        System.err.println("e.printStackTrace():");
                        e.printStackTrace(System.err);
                } finally {
                        send("q"); // tell external GF process to quit
                        if (isClassInv) { // send linearization as a class invariant
                                TempGrammarFiles.cleanupFromUMLTypes(callbackClassInv.getGrammarsDir());
                        } else if (isPrePost) { // send lin. as pre-/postconditions
                                //callbackPrePost.sendPrePost(compactSpaces(preCond.trim()), compactSpaces(postCond.trim()));
                                TempGrammarFiles.cleanupFromUMLTypes(callbackPrePost.getGrammarsDir());
                        }     
                        this.removeAll();
                        this.dispose();
                }
        }
        
    	/** just replace sequences of spaces with one space */
    	private static String compactSpaces(String s)
    	{
    		String localResult = new String();
    		boolean spaceIncluded = false;
    		
    		for (int i = 0; i < s.length(); i++)
    		{
    			char c = s.charAt(i);
    			if (c != ' ') { // include all non-spaces
    				localResult += String.valueOf(c);
    				spaceIncluded = false;
    			} else {// we have a space
    				if (!spaceIncluded) {
    					localResult += " ";
    					spaceIncluded = true;
    				} // else just skip
    			}
    		}
    		return localResult;
    	}		
        
        /**
         * fills the menu with the possible actions like refinements
         * with the available ones.
         * Parses the GF-output between <menu> and </menu>  tags
         * and fills the corrsponding GUI list -"Select Action".
         * seems to expect the starting menu tag to be already read
         */
    	protected void formSelectMenu (){
                if (debugXML) System.out.println("list model changing! ");      
                String s ="";
                try {
                        //read item
                        result = fromProc.readLine();
                        if (debugXML) System.out.println("8 "+result);
                        listModel.clear();
                        commands.clear();
                        while (result.indexOf("/menu")==-1){
                                //read show
                                result = fromProc.readLine();
                                if (debugXML) System.out.println("8 "+result);
                                while (result.indexOf("/show")==-1){          
                                        result = fromProc.readLine();
                                        if (debugXML) System.out.println("9 "+result);
                                        if (result.indexOf("/show")==-1) 
                                        {
                                                if (result.length()>8)
                                                        s+=result.trim();
                                                else
                                                        s+=result;    
                                        }
                                }            
                                //          if (s.charAt(0)!='d')
                                //            listModel.addElement("Refine " + s);
                                //          else 
                                listModel.addElement(s);
                                s="";
                                //read /show
                                //read send
                                result = fromProc.readLine();
                                if (debugXML) System.out.println("8 "+result);
                                result = fromProc.readLine();
                                if (debugXML) System.out.println("8 "+result);
                                saveCommand(this.result, this.newObject);
                                //read /send (discarded)
                                result = fromProc.readLine();             
                                if (debugXML) System.out.println("8 "+result);          
                                
                                // read /item
                                result = fromProc.readLine();
                                if (debugXML) System.out.println("8 "+result);
                                result = fromProc.readLine();
                                if (debugXML) System.out.println("8 "+result);
                        }
                } catch(IOException e){
                        System.err.println(e.getMessage());
                        e.printStackTrace();
                }
        }
        
        /**
         * puts the current line in result into commands, hoping, that
         * it really is one, then reads the next
         * @param command the command to be saved
         */
    	protected void saveCommand(String command, boolean really){
                if (really) this.commands.add(command);
        }

        protected void readHmsg(){
                if (logger.isDebugEnabled() && debugXML) {
                        logger.debug("readHmsg");
                }
                StringBuffer s =new StringBuffer("");
                try {
                        result = fromProc.readLine();
                        if (debugXML) System.out.println("7 "+result);
                        while (result.indexOf("/hmsg")==-1){       
                                s.append(result).append('\n');           
                                result = fromProc.readLine();
                                if (debugXML) System.out.println("7 "+result);                     
                        }
                        if (s.indexOf("c") > -1) {
                                //clear output before linearization
                                this.linearizationArea.setText("");
                                outputVector = new Vector();
                        }
                        if (s.indexOf("t") > -1) {
                                //tree has changed
                                this.treeChanged = true;
                        }
                        if (s.indexOf("n") > -1) {
                                //a new object has been created
                                this.newObject = true;
                        }
                        result = fromProc.readLine();             
                        if (debugXML) System.out.println("7 "+result);          
                } catch(IOException e){
                        System.err.println(e.getMessage());
                        e.printStackTrace();
                }
        }

        
        /**
         * reads the linearizations in all language.
         * seems to expect the first line of the XML structure 
         * (< lin) already to be read
         * Accumulates the GF-output between <linearization> </linearization>  tags
         */
        protected void readLin(){
                if (logger.isDebugEnabled() && debugXML) {
                        logger.debug("readLin");
                }
                try {
                        linearization="";  
                        linearization += result+"\n";           
                        result = fromProc.readLine();
                        if (debugXML) System.out.println("6 "+result);
                        while ((result!=null)&&(result.indexOf("/linearization")==-1)){       
                                linearization += result+"\n";           
                                result = fromProc.readLine();
                                if (debugXML) System.out.println("6 "+result);                     
                        }
                        if (newObject) formLin();     
                        result = fromProc.readLine();             
                        if (debugXML) System.out.println("6 "+result);          
                } catch(IOException e){
                        System.err.println(e.getMessage());
                        e.printStackTrace();
                }
        }
        
        /**
         * reads in the tree and calls formTree without start end end tag of tree
         * expects the first starting XML tag tree to be already read
         */
        protected void readTree(){
                if (logger.isDebugEnabled() && debugXML) {
                        logger.debug("readTree");
                }
                String treeString = "";
                try {
                        result = fromProc.readLine();
                        if (debugXML) System.out.println("6 "+result);
                        while (result.indexOf("/tree")==-1){       
                                treeString += result+"\n";           
                                result = fromProc.readLine();
                                if (debugXML) System.out.println("6 "+result);                     
                        }
                        if (treeChanged && (newObject)) {
                                formTree(tree, treeString); 
                                treeChanged = false;  
                        } 
                        treeString="";                     
                        result = fromProc.readLine();             
                        if (debugXML) System.out.println("6 "+result);          
                } catch(IOException e){
                        System.err.println(e.getMessage());
                        e.printStackTrace();
                }
        }
        
        /**
         * Parses the GF-output between <message> </message>  tags
         * and puts it in the linearization area.
         * seems to expect the opening message tag to be already read
         */
        protected void readMessage(){
                if (logger.isDebugEnabled() && debugXML) {
                        logger.debug("readMessage");
                }
                String s ="";
                try {
                        result = fromProc.readLine();
                        if (debugXML) System.out.println("7 "+result);
                        while (result.indexOf("/message")==-1){       
                                s += result+"\n";           
                                result = fromProc.readLine();
                                if (debugXML) System.out.println("7 "+result);                     
                        }
                        if (s.length()>1)
                                appendMarked("-------------"+'\n'+s,-1,-1, null);  
                        result = fromProc.readLine();             
                        if (debugXML) System.out.println("7 "+result);          
                } catch(IOException e){
                        System.err.println(e.getMessage());
                        e.printStackTrace();
                }
        }
 
        /**
         * reads the cat entries and puts them into menu, and after that reads
         * the names of the languages and puts them into the language menu
         * Parses the GF-output between <gfinit> tags
         * and fill the New combobox in the GUI.
         */
        protected void formNewMenu () {
                boolean more = true;
                try {
                        //read first cat
                        result = fromProc.readLine();
                        if (debugXML) System.out.println("2 "+result);
                        
                        while (more){
                                //adds new cat s to the menu
                                if (result.indexOf("topic")==-1) {
                                        newCategoryMenu.addItem(result.substring(6));                       
                                } 
                                else 
                                        more = false;
                                //read </newcat
                                result = fromProc.readLine();
                                if (debugXML) System.out.println("2 "+result);
                                //read <newcat (normally)
                                result = fromProc.readLine();
                                if (debugXML) System.out.println("3 "+result); 
                                if (result.indexOf("topic")!=-1) 
                                        more = false; 
                                //read next cat
                                result = fromProc.readLine();             
                                if (debugXML) System.out.println("4 "+result);       
                        }
                        //set topic
                        grammar.setText(result.substring(4)+"          ");
                        //read end of topic and language
                        result = fromProc.readLine();
                        if (debugXML) System.out.println("2 "+result); 
                        result = fromProc.readLine();
                        if (debugXML) System.out.println("3 "+result); 
                        result = fromProc.readLine();             
                        if (debugXML) System.out.println("4 "+result);       
                        
                        //read the languages and select the last non-abstract
                        more = true;
                        while (more){
                                if ((result.indexOf("/gfinit")==-1)&&(result.indexOf("lin")==-1)) {         
                                        //form lang and Menu menu: 
                                        cbMenuItem = new JCheckBoxMenuItem(result.substring(4));
                                        if (debugXML) System.out.println ("menu item: "+result.substring(4));   
                                        if ((result.substring(4)).equals("Abstract"))
                                                cbMenuItem.setSelected(false);
                                        else 
                                                cbMenuItem.setSelected(true);
                                        cbMenuItem.setActionCommand("lang");
                                        cbMenuItem.addActionListener(myListener);
                                        langMenu.add(cbMenuItem);
                                        /*        
                                         {
                                         submenu.add(rbMenuItemAbs);
                                         if (selectedMenuLanguage.equals("Abstract"))
                                         rbMenuItemAbs.setSelected(true);
                                         languageGroup.add(rbMenuItemAbs); 
                                         }
                                         else
                                         {
                                         */
                                        rbMenuItem = new JRadioButtonMenuItem(result.substring(4));
                                        rbMenuItem.setActionCommand(result.substring(4));
                                        rbMenuItem.addActionListener(myListener);
                                        languageGroup.add(rbMenuItem);
                                        if ((result.substring(4)).equals(selectedMenuLanguage))
                                        {
                                                if (debugXML) System.out.println("Selecting "+selectedMenuLanguage);
                                                rbMenuItem.setSelected(true);
                                        }
                                        
                                        submenu.add(rbMenuItem);
                                        // }
                                } 
                                else 
                                        more = false;
                                // read </language>
                                result = fromProc.readLine();
                                if (debugXML) System.out.println("2 "+result); 
                                // read <language> or </gfinit...>
                                result = fromProc.readLine();
                                if (debugXML) System.out.println("3 "+result); 
                                if ((result.indexOf("/gfinit")!=-1)||(result.indexOf("lin")!=-1)) 
                                        more = false; 
                                if (result.indexOf("/gfinit")!=-1)
                                        finished = true;
                                // registering the file name:
                                if (result.indexOf("language")!=-1) {
                                        String path = result.substring(result.indexOf('=')+1,
                                                        result.indexOf('>')); 
                                        path =path.substring(path.lastIndexOf('/')+1);
                                        if (debugXML) System.out.println("name: "+path);
                                        fileString +="--" + path +"\n";
                                        if (path.lastIndexOf('.')!=path.indexOf('.'))
                                                grammar.setText(path.substring(0,
                                                                path.indexOf('.')).toUpperCase()+"          ");
                                }
                                result = fromProc.readLine();             
                                if (debugXML) System.out.println("4 "+result);               
                        }
                        if (debugXML) 
                                System.out.println("languageGroupElement formed"+ 
                                                languageGroup.getButtonCount());                   
                        langMenu.addSeparator();
                        fileMenuItem = new JMenuItem("Add...");
                        fileMenuItem.setActionCommand("import");
                        fileMenuItem.addActionListener(this);     
                        langMenu.add(fileMenuItem);
                        // in order to get back in main in the beggining of while:
                        result = fromProc.readLine();
                } catch(IOException e){
                        logger.warn(e.getMessage());
                }
        }
        
        /**
         * Parses the GF-output between <lin> </lin>  tags
         * and puts the string in the linearization area on the screen
         * 
         * parses the focus parts of result (expects a lin in there)
         * and calls appendMarked with this information.
         * results seems to be the text only lin afterwards.
         *
         */
        protected StringBuffer outputAppend(){
                StringBuffer linCollector = new StringBuffer();
                int i, j, j2, k, l, l2, selectionLength, m=0, n=0;
                //result=result.replace('\n',' ');
                if (debugLinMarking) 
                        System.out.println("INPUT:"+result);
                l = this.result.indexOf("<focus");
                i=result.indexOf("type=",l);
                j=result.indexOf('>',i);
                //the color of the highlighted parts of the linearization
                Color color;
                // status incorrect ?:
                if ((i > -1) && (this.result.substring(i,j).indexOf("incorrect")!=-1))
                {  
                        j2 = result.indexOf("status");
                        color = Color.red;
                }
                else 
                {
                        j2 = j;
                        color = Color.green;
                }
                l2 = this.result.indexOf("focus");    
                if (l2!=-1){
                        // in case focus tag is cut into two lines:
                        if (l==-1) l=l2-7;         
                        m=this.result.indexOf("position",l);
                        if (debugLinMarking) System.out.println("POSITION START: "+m); 
                        n=this.result.indexOf("]",m);
                        if (debugLinMarking) System.out.println("POSITION END: "+n); 
                        if (debugXML)
                                System.out.println("form Lin1: "+this.result);
                        this.focusPosition = new LinPosition(result.substring(m+9,n+1),
                                        this.result.substring(m,j).indexOf("incorrect")==-1);
                        statusLabel.setText(" "+result.substring(i+5,j2));
                        //cutting <focus>
                        this.result= this.result.substring(0,l)+this.result.substring(j+2);
                        i=this.result.indexOf("/focus",l);
                        selectionLength = i-l-1;
                        if (debugLinMarking) 
                                System.out.println("selection length: "+selectionLength);
                        j=this.result.indexOf('>',i);
                        k=this.result.length()-j-1;
                        if (debugXML) System.out.println("form Lin2: "+this.result);
                        
                        if (debugXML)
                                System.out.println("char at the previous position"+this.result.charAt(i-1));
                        //cutting </focus>    
                        // in case focus tag is cut into two lines:
                        if (this.result.charAt(i-1)!='<') 
                                // check if punktualtion marks like . ! ? are at the end of a sentence:
                                if (this.result.charAt(j+1)==' ')
                                        this.result= this.result.substring(0,i-8)+this.result.substring(j+2);
                                else
                                        this.result= this.result.substring(0,i-9)+this.result.substring(j+1);
                        else
                                if (this.result.charAt(j+1)==' ')
                                        this.result= this.result.substring(0,i-1)+this.result.substring(j+2);
                                else
                                        this.result= this.result.substring(0,i-2)+this.result.substring(j+1);
                        j= this.result.indexOf("<focus");
                        l2 = this.result.indexOf("focus");    
                        // in case focus tag is cut into two lines:
                        if ((l2!=-1)&&(j==-1)) j=l2-7;
                        
                        // appending the this.resulting string
                        // only one focus 
                        if (j==-1){
                                if (debugLinMarking) 
                                        System.out.println("ONE FOCUS");
                                // last space is not included!:
                                // beware the side-effects! They are, what counts
                                linCollector.append(appendMarked(this.result+'\n',l,l+selectionLength-2, color)); 
                        } 
                        //several focuses
                        else {
                                if (debugLinMarking) 
                                        System.out.println("MANY FOCUSes");
//                              beware the side-effects! They are, what counts
                                linCollector.append(appendMarked(this.result.substring(0,j),l,l+selectionLength-2, color));           
                                this.result = this.result.substring(j);
//                              beware the side-effects! They are, what counts
                                linCollector.append(outputAppend());
                        }
                        if (debugXML) System.out.println("form Lin3: "+this.result);
                } else {//no focus at all (message?):
//                      beware the side-effects! They are, what counts
                        linCollector.append(appendMarked(this.result+'\n', -1,-1, null));
                }
                this.firstLin=false;
//                if (logger.isDebugEnabled()) {
//                        logger.debug("collected appended linearizations:\n" + linCollector.toString());
//                }
                return linCollector;
        }

        
        /**
         * Parses the GF-output between <linearization> </linearization>  tags
         * 
         * pseudo-parses the XML lins and fills the output text area
         * with the lin in all enabled languages
         */
        protected void formLin(){
                boolean visible=true; 
                firstLin=true; 
                result = linearization.substring(0,linearization.indexOf('\n'));
                String lin = linearization.substring(linearization.indexOf('\n')+1);
                //extract the language from result
                int ind = result.indexOf('=');
                int ind2 = result.indexOf('>');
                //The language of the linearization
                String language = result.substring(ind+1,ind2);
                result = lin.substring(0,lin.indexOf("</lin>"));
                lin = lin.substring(lin.indexOf("</lin>"));
                while (lin.length()>1) {
                        //check if the language is on     
                        if (!visible) {
                                visible = true;       
                        }
                        // in the list?
                        for (int i=0; i<langMenu.getItemCount()-2;i++)        
                                if (langMenu.getItem(i).getText().equals(language)) {
                                        visible = false;
                                        break; 
                                }
                        if (!visible) {
                                visible = true;       
                        } else {
                                //add item to the language list:
                                cbMenuItem = new JCheckBoxMenuItem(language);
                                if (debugXML) System.out.println ("menu item: "+language);   
                                cbMenuItem.setSelected(true);
                                cbMenuItem.setActionCommand("lang");
                                cbMenuItem.addActionListener(myListener);
                                if (langMenu.getItemCount()<2) {
                                        langMenu.add(cbMenuItem, langMenu.getItemCount());
                                } else {
                                        langMenu.add(cbMenuItem, langMenu.getItemCount()-2);
                                }
                                
                                rbMenuItem = new JRadioButtonMenuItem(language);
                                rbMenuItem.setActionCommand(language);
                                rbMenuItem.addActionListener(myListener);
                                languageGroup.add(rbMenuItem);
                                submenu.add(rbMenuItem);
                                
                        }
                        // selected?
                        for (int i=0; i<langMenu.getItemCount()-2;i++) {
                                if ((langMenu.getItem(i).getText().equals(language))&&
                                                !(langMenu.getItem(i).isSelected()) ) {
                                        visible = false;
                                        break; 
                                }
                        }
                        if (visible) {   
                                if (!firstLin) {
                                        appendMarked("\n************"+'\n',-1,-1, null);
                                }
                                if (debugXML) {
                                        System.out.println("linearization for the language: "+result);
                                }
                                // we want the side-effects of outputAppend
                                String linResult = outputAppend().toString();
                                linearizations.put(language, linResult);
                        }
                        // read </lin>
                        lin = lin.substring(lin.indexOf('\n')+1);
                        // read lin or 'end'
                        if (lin.length()<1) {
                                break;
                        }
                        
                        result = lin.substring(0,lin.indexOf('\n'));
                        lin = lin.substring(lin.indexOf('\n')+1);
                        if (result.indexOf("<lin ")!=-1){
                                //extract the language from result
                                ind = result.indexOf('=');
                                ind2 = result.indexOf('>');
                                language = result.substring(ind+1,ind2);
                                result = lin.substring(0,lin.indexOf("</lin>"));
                                lin = lin.substring(lin.indexOf("</lin>"));
                        }  
                }
                
                //do highlighting
                for (int i = 0; i<outputVector.size(); i++)  {
                        MarkedArea ma = (MarkedArea)outputVector.elementAt(i) ;              
                        int begin = ma.begin ;
                        int end = ma.end ;
                        if (debugRed) 
                                System.out.println("BEGIN: "+ begin +" END: "+end+" "+ma.words+" "+ma.position.position);
                        if (!ma.position.correctPosition) {
                                try {  
                                        linearizationArea.getHighlighter().addHighlight(begin, end, new DefaultHighlighter.DefaultHighlightPainter(Color.red));
                                        if (debugRed) { 
                                                System.out.println("HIGHLIGHT: "+linearizationArea.getText().substring(begin, end));
                                        }
                                } catch (Exception e) {
                                        System.out.println("highlighting problem!");
                                }
                        }
                        //completeLin.append(ma.words);
                }
//                if (logger.isDebugEnabled()) {
//                        logger.debug("completeLin: \n" + completeLin);
//                }
        }
        
        /**
         *  Sets the font on all the GUI-elements to font.
         */
        protected void fontEveryWhere(Font font) {                          
                linearizationArea.setFont(font);  
                parseField.setFont(font);  
                tree.tree.setFont(font);  
                refinementList.setFont(font);  
                sizeList.setFont(font);  
                popup2.setFont(font);  
                sizeLabel.setFont(font);  
                save.setFont(font);  
                fontList.setFont(font);  
                fontLabel.setFont(font);  
                grammar.setFont(font);  
                open.setFont(font);  
                newTopic.setFont(font);  
                gfCommand.setFont(font);  
                leftMeta.setFont(font);  
                left.setFont(font);  
                top.setFont(font);  
                right.setFont(font);  
                rightMeta.setFont(font);  
                read.setFont(font);  
                alpha.setFont(font);  
                random.setFont(font);  
                undo.setFont(font);  
                ok.setFont(font);  
                cancel.setFont(font);  
                inputLabel.setFont(font);  
                browse.setFont(font);  
                termReadButton.setFont(font);  
                stringReadButton.setFont(font);  
                filter.setFont(font);  
                modify.setFont(font);  
                statusLabel.setFont(font);  
                menuBar.setFont(font);
                newCategoryMenu.setFont(font);  
                
                submenu.setFont(font);  
                recursion(submenu, font);
                modeMenu.setFont(font);  
                recursion(modeMenu, font);
                langMenu.setFont(font);  
                recursion(langMenu, font);
                fileMenu.setFont(font);  
                recursion(fileMenu, font);
                viewMenu.setFont(font);  
                recursion(viewMenu, font);
                
        }
        
        /**
         * Set the font in the submenus 
         */
        protected void recursion(JMenu subMenu, Font font)
        {  
                for (int i = 0; i<subMenu.getItemCount(); i++)
                { 
                        JMenuItem item = subMenu.getItem(i);
                        if (item != null) 
                        {
                                item.setFont(font);
                                String name = item.getClass().getName();
                                if (debugXML) System.out.println(name);
                        }
                }
        }
        
        public void actionPerformed(ActionEvent ae)
        {  
                boolean abs = true;
                Object obj = ae.getSource();
                
                if ( obj == fontList ) {
                        font = new Font((String)fontList.getSelectedItem(), Font.PLAIN, ((Integer)sizeList.getSelectedItem()).intValue());
                        //output.setFont(font);  
                        fontEveryWhere(font);
                        if (cbMenuItem!=null) cbMenuItem.setFont(font);  
                        if (rbMenuItem!=null) rbMenuItem.setFont(font);  
                        if (fileMenuItem!=null) fileMenuItem.setFont(font);  
                }
                
                if ( obj == sizeList ) {
                        font = new Font((String)fontList.getSelectedItem(), Font.PLAIN, ((Integer)sizeList.getSelectedItem()).intValue());
                        fontEveryWhere(font);
                        if (cbMenuItem!=null) cbMenuItem.setFont(font);  
                        if (rbMenuItem!=null) rbMenuItem.setFont(font);  
                        if (fileMenuItem!=null) fileMenuItem.setFont(font);  
                }
                
                if ( obj == newCategoryMenu ) {
                        if (!newCategoryMenu.getSelectedItem().equals("New"))           
                        { 
                                treeChanged = true; 
                                send("n " + newCategoryMenu.getSelectedItem());
                                newObject = true;
                                newCategoryMenu.setSelectedIndex(0);
                        }
                }
                if ( obj == filter ) {
                        if (!filter.getSelectedItem().equals("Filter"))           
                        { 
                                send("f " + filter.getSelectedItem());
                                System.out.println("sending f " + filter.getSelectedItem());
                                filter.setSelectedIndex(0);
                        }
                }
                if ( obj == modify ) {
                        if (!modify.getSelectedItem().equals("Modify"))           
                        { 
                                treeChanged = true; 
                                send("c " + modify.getSelectedItem());
                                modify.setSelectedIndex(0);
                        }
                }
                if (obj==timer2){
                        if (debugPopUp) System.out.println("changing pop-up menu2!");
                        popup2.removeAll();
                        for (int i = 0; i<listModel.size() ; i++) 
                                addMenuItem(listModel.elementAt(i).toString());
                        popup2.show(mouseEvent2.getComponent(), mouseEvent2.getX(), mouseEvent2.getY());
                }
                
                /*    if ( obj == mode ) {
                 if (!mode.getSelectedItem().equals("Menus"))           
                 {  
                 send("o " + mode.getSelectedItem());
                 mode.setSelectedIndex(0);              
                 }               
                 }
                 */
                // buttons and menu items: 
                try {
                        Class c = Class.forName("javax.swing.AbstractButton");
                        boolean b = c.isInstance(obj); 
                        if (b) {
                                String name =((AbstractButton)obj).getActionCommand();
                                
                                if (name.equals("popupMenuItem")){
                                        treeChanged = true; 
                                        send((String)commands.elementAt
                                                        (popup2.getComponentIndex((JMenuItem)(ae.getSource()))));
                                }                   
                                
                                if ( name.equals("quit")) {
                                        endProgram();
                                }
                                
                                if ( name.equals("save") ) {
                                        
                                        if (saveFc.getChoosableFileFilters().length<2)
                                                saveFc.addChoosableFileFilter(new GrammarFilter()); 
                                        int returnVal = saveFc.showSaveDialog(GFEditor2.this);
                                        if (returnVal == JFileChooser.APPROVE_OPTION) {
                                                File file = saveFc.getSelectedFile();
                                                if (debugXML) System.out.println("saving ... ");
                                                
                                                // checking if the abstract syntax is on:
                                                for (int i=0; i<langMenu.getItemCount()-2;i++)
                                                        if ((langMenu.getItem(i).getText().equals("Abstract"))&&
                                                                        !(langMenu.getItem(i).isSelected()) ) {
                                                                if (debugXML) System.out.println("No Abstract syntax !!!!");
                                                                abs = false;
                                                                break; 
                                                        }
                                                        
                                                String text = linearizationArea.getText();
                                                int end = text.indexOf("******");
                                                
                                                // saving as a term:
                                                if (saveTypeGroup.getSelection().getActionCommand().equals("term")) {
                                                        if (end !=-1)
                                                                if (abs) {
                                                                        // writeOutput(fileString+text.substring(0, end), file.getPath());
                                                                        writeOutput(text.substring(0, end), file.getPath());
                                                                        abs=true;
                                                                }
                                                                else {
                                                                        int i = linearization.indexOf('\n');
                                                                        int j = linearization.indexOf("/lin");
                                                                        //writeOutput(fileString+linearization.substring(i+1, j-1), file.getPath());
                                                                        writeOutput(linearization.substring(i+1, j-1), file.getPath());
                                                                } 
                                                        else
                                                                JOptionPane.showMessageDialog(this, "No term to save");   
                                                }  
                                                // saving as a linearization:
                                                else  
                                                        // abstract syntax is shown:
                                                        if (abs){
                                                                end =  text.indexOf('\n', end);
                                                                //writeOutput(fileString+text.substring(end), file.getPath());
                                                                writeOutput(text.substring(end), file.getPath());
                                                                abs = true;
                                                        }
                                                        else
                                                                //writeOutput(fileString+text, file.getPath());
                                                                writeOutput(text, file.getPath());
                                        }           
                                }
                                
                                if ( name.equals("open") ) {
                                        if (saveFc.getChoosableFileFilters().length<2)
                                                saveFc.addChoosableFileFilter(new GrammarFilter()); 
                                        int returnVal = saveFc.showOpenDialog(GFEditor2.this);
                                        if (returnVal == JFileChooser.APPROVE_OPTION) {
                                                
                                                /* "sending" should be fixed on the GF side:
                                                 rbMenuItemLong.setSelected(true);
                                                 send("ms long");
                                                 rbMenuItemUnTyped.setSelected(true);
                                                 send("mt untyped");
                                                 selectedMenuLanguage = "Abstract";
                                                 rbMenuItemAbs.setSelected(true);
                                                 send("ml Abs");
                                                 */
                                                
                                                treeChanged = true; 
                                                newObject = true;
                                                while (1< newCategoryMenu.getItemCount())
                                                        newCategoryMenu.removeItemAt(1);
                                                langMenu.removeAll();
                                                
                                                AbstractButton ab = null;
                                                
                                                while (languageGroup.getButtonCount()>0)
                                                {
                                                        for (Enumeration e = languageGroup.getElements(); 
                                                        e.hasMoreElements() ;) 
                                                        {
                                                                ab = (AbstractButton)e.nextElement();
                                                                if (debugXML) System.out.println("more to remove ! "+ab.getText()); 
                                                                languageGroup.remove(ab);
                                                        }
                                                        if (debugXML) System.out.println("languageGroupElement after import removal "+ 
                                                                        languageGroup.getButtonCount());                   
                                                }
                                                submenu.removeAll();
                                                
                                                
                                                File file = saveFc.getSelectedFile();
                                                // opening the file for editing :
                                                if (debugXML) System.out.println("opening: "+ file.getPath().replace('\\','/'));
                                                if (saveTypeGroup.getSelection().getActionCommand().equals("term")) {
                                                        if (debugXML) System.out.println(" opening as a term ");
                                                        send("open "+ file.getPath().replace('\\','/'));         
                                                }
                                                else {
                                                        if (debugXML) System.out.println(" opening as a linearization ");
                                                        send("openstring "+ file.getPath().replace('\\','/'));
                                                }
                                                
                                                fileString ="";
                                                grammar.setText("No Topic          ");
                                        }           
                                }
                                
                                if ( name.equals("import") ) {
                                        if (fc.getChoosableFileFilters().length<2)
                                                fc.addChoosableFileFilter(new GrammarFilter()); 
                                        int returnVal = fc.showOpenDialog(GFEditor2.this);
                                        if (returnVal == JFileChooser.APPROVE_OPTION) {
                                                File file = fc.getSelectedFile();
                                                // importing a new language :
                                                langMenu.removeAll();
                                                AbstractButton ab = null;
                                                while (languageGroup.getButtonCount()>0)
                                                {
                                                        for (Enumeration e = languageGroup.getElements(); 
                                                        e.hasMoreElements() ;) 
                                                        {
                                                                ab = (AbstractButton)e.nextElement();
                                                                if (debugXML) System.out.println("more to remove ! "+ab.getText()); 
                                                                languageGroup.remove(ab);
                                                        }
                                                        if (debugXML) System.out.println("languageGroupElement after import removal "+ 
                                                                        languageGroup.getButtonCount());                   
                                                }
                                                
                                                submenu.removeAll();                         
                                                while (1< newCategoryMenu.getItemCount())
                                                        newCategoryMenu.removeItemAt(1);
                                                if (debugXML) System.out.println("importing: "+ file.getPath().replace('\\','/'));
                                                
                                                fileString ="";
                                                send("i "+ file.getPath().replace('\\','/'));  
                                                
                                        }           
                                }
                                if ( name.equals("newTopic") ) {
                                        if (fc.getChoosableFileFilters().length<2)
                                                fc.addChoosableFileFilter(new GrammarFilter()); 
                                        int returnVal = fc.showOpenDialog(GFEditor2.this);
                                        if (returnVal == JFileChooser.APPROVE_OPTION) {
                                                int n = JOptionPane.showConfirmDialog(this,
                                                                "This will dismiss the previous editing. Would you like to continue?",
                                                                "Starting a new topic", JOptionPane.YES_NO_OPTION);
                                                if (n == JOptionPane.YES_OPTION){
                                                        File file = fc.getSelectedFile();
                                                        // importing a new grammar :                
                                                        newObject = false; 
                                                        statusLabel.setText(status); 
                                                        listModel.clear();
                                                        tree.clear();
                                                        populateTree(tree);
                                                        while (1< newCategoryMenu.getItemCount())
                                                                newCategoryMenu.removeItemAt(1);
                                                        langMenu.removeAll();
                                                        
                                                        AbstractButton ab = null;
                                                        
                                                        while (languageGroup.getButtonCount()>0)
                                                        {
                                                                for (Enumeration e = languageGroup.getElements(); 
                                                                e.hasMoreElements() ;) 
                                                                {
                                                                        ab = (AbstractButton)e.nextElement();
                                                                        if (debugXML) System.out.println("more to remove ! "+ab.getText()); 
                                                                        languageGroup.remove(ab);
                                                                }
                                                                if (debugXML) System.out.println("languageGroupElement after import removal "+ 
                                                                                languageGroup.getButtonCount());                   
                                                        }
                                                        
                                                        selectedMenuLanguage = "Abstract";
                                                        rbMenuItemLong.setSelected(true);
                                                        rbMenuItemUnTyped.setSelected(true);
                                                        submenu.removeAll();
                                                        
                                                        fileString="";
                                                        grammar.setText("No Topic          ");
                                                        send(" e "+ file.getPath().replace('\\','/'));
                                                }
                                        }           
                                }
                                
                                if ( obj == gfCommand ){
                                        String s = JOptionPane.showInputDialog("Command:", parseInput);
                                        if (s!=null) {
                                                parseInput = s;
                                                //s = "gf "+s; This is for debugging, otherwise shift the comment to the next line.
                                                treeChanged = true; 
                                                if (debugXML) System.out.println("sending: "+ s);
                                                send(s);
                                        }
                                }
                                
                                if ( name.equals("reset") ) {
                                        newObject = false; 
                                        statusLabel.setText(status); 
                                        listModel.clear();
                                        tree.clear();
                                        populateTree(tree);
                                        while (1< newCategoryMenu.getItemCount())
                                                newCategoryMenu.removeItemAt(1);
                                        langMenu.removeAll();
                                        
                                        AbstractButton ab = null;
                                        
                                        while (languageGroup.getButtonCount()>0)
                                        {
                                                for (Enumeration e = languageGroup.getElements(); 
                                                e.hasMoreElements() ;) 
                                                {
                                                        ab = (AbstractButton)e.nextElement();
                                                        if (debugXML) System.out.println("more to remove ! "+ab.getText()); 
                                                        languageGroup.remove(ab);
                                                }
                                                if (debugXML) System.out.println("languageGroupElement after import removal "+ 
                                                                languageGroup.getButtonCount());                   
                                        }
                                        
                                        selectedMenuLanguage = "Abstract";
                                        
                                        submenu.removeAll();
                                        rbMenuItemLong.setSelected(true);
                                        rbMenuItemUnTyped.setSelected(true);
                                        
                                        fileString="";
                                        grammar.setText("No Topic          ");
                                        send("e");
                                }
                                
                                if ( obj == leftMeta ) {
                                        treeChanged = true; 
                                        send("<<");
                                }
                                if ( obj == left ) {
                                        treeChanged = true; 
                                        send("<");
                                }
                                if ( obj == top ) {
                                        treeChanged = true; 
                                        send("'");
                                }
                                if ( obj == right ) {
                                        treeChanged = true; 
                                        send(">");
                                }
                                if ( obj == rightMeta ) {
                                        treeChanged = true; 
                                        send(">>");
                                }
                                
                                if ( obj == cancel ) {
                                        readDialog.hide();
                                }
                                
                                if ( obj == browse ) {
                                        if (fc.getChoosableFileFilters().length<2)
                                                fc.addChoosableFileFilter(new GrammarFilter()); 
                                        int returnVal = fc.showOpenDialog(GFEditor2.this);
                                        if (returnVal == JFileChooser.APPROVE_OPTION) {
                                                File file = fc.getSelectedFile();
                                                inputField.setText(file.getPath().replace('\\','/'));
                                        }
                                }
                                
                                if ( obj == ok ) {
                                        treeChanged = true; 
                                        if (termReadButton.isSelected()) { 
                                                termInput = inputField.getText();
                                                if (termInput.indexOf('/')==-1){
                                                        send("g "+termInput); 
                                                        if (debugXML) System.out.println("sending term  string");
                                                }
                                                else {
                                                        send("tfile "+termInput);                           
                                                        System.out.println("sending file term: "+termInput);          
                                                }
                                        }   
                                        else {
                                                parseInput = inputField.getText();
                                                if (parseInput.indexOf('/')==-1){
                                                        send("p "+parseInput);        
                                                        if (debugXML) System.out.println("sending parse string: "+parseInput);
                                                }   
                                                else {
                                                        send("pfile "+parseInput);           
                                                        if (debugXML) System.out.println("sending file parse string: "+parseInput);        
                                                }
                                        }
                                        readDialog.hide();
                                }
                                
                                if ( obj == read ) {
                                        if (stringReadButton.isSelected())
                                                inputField.setText(parseInput);
                                        else
                                                inputField.setText(termInput);
                                        readDialog.show();
                                }   
                                
                                /*        if ( obj == term ) {
                                 inputLabel.setText("Term:");
                                 inputField.setText(termInput);
                                 dialog.show();
                                 }
                                 if ( obj == parse ) {
                                 inputLabel.setText("Parse:");
                                 inputField.setText(parseInput);
                                 dialog.show();
                                 }
                                 */
                                if ( obj == alpha){
                                        String s = JOptionPane.showInputDialog("Type string:", alphaInput);
                                        if (s!=null) {
                                                alphaInput = s;
                                                treeChanged = true; 
                                                send("x "+s);
                                        }      
                                }
                                if ( obj == random){
                                        treeChanged = true; 
                                        send("a");
                                }
                                if ( obj == undo){
                                        treeChanged = true; 
                                        send("u");
                                }
                        }
                } catch (Exception e){
                        System.err.println(e.getMessage());
                        e.printStackTrace();
                }
        }
        static void writeOutput(String str, String fileName) {
                
                try {
                        FileOutputStream fos = new FileOutputStream(fileName);
                        Writer out = new OutputStreamWriter(fos, "UTF8");
                        out.write(str);
                        out.close();
                } catch (IOException e) {
                        JOptionPane.showMessageDialog(null, 
                                        "Document is empty!","Error", JOptionPane.ERROR_MESSAGE);
                }
        }
        
        /**
         * Form a dummy tree in treePanel
         * @param the aforementioned treePanel
         */
        protected void populateTree(DynamicTree2 treePanel) {
                String p1Name = new String("Root");
                DefaultMutableTreeNode p1;
                p1 = treePanel.addObject(null, p1Name);
        }
        
        /**
         * Parses the GF-output between <tree> </tree>  tags
         * and build the corresponding tree.
         * 
         * parses the already read XML for the tree and stores the tree nodes
         * in nodeTable with their numbers as keys
         * @param treePanel the panel of GFEditor2
         * @param treeString the string representation for the XML tree
         */
        protected void formTree(DynamicTree2 treePanel, String treeString) {
                Hashtable table = new Hashtable();
                TreePath path=null;
                boolean treeStarted = false, selected = false;  
                String s = treeString;
                String name ="";
                treePanel.clear();
                int j, shift=0, star=0, index = 0;
                DefaultMutableTreeNode p2=null, p1=null;
                if (debugTree) System.out.print("treeString: "+ s);
                if (s.indexOf('*')!=-1) star = 1; 
                while (s.length()>0) {
                        while ((s.length()>0) && ((s.charAt(0)=='*')||(s.charAt(0)==' '))){      
                                if (s.charAt(0) == '*') selected = true;
                                s = s.substring(1);     
                                shift++;  
                        }             
                        if (s.length()>0) {
                                j = s.indexOf("\n");      
                                name = s.substring(0, j);     
                                index++;
                                s = s.substring(j+1);    
                                shift = (shift - star)/2;
                                
                                p1 = (DefaultMutableTreeNode)table.get(new Integer(shift));
                                p2 = treePanel.addObject(p1, name);  
                                table.put(new Integer(shift+1), p2);
                                path = new TreePath(p2.getPath());
                                nodeTable.put(path, new Integer(index));
                                if (selected) {                        
                                        treePanel.tree.setSelectionPath(path);              
                                        treePanel.oldSelection = index;
                                        if (debugTree) System.out.println("new selected index "+ index);
                                        selected = false;
                                }
                                treeStarted=true;               
                        }
                        shift = 0;
                }
                if ((p2!=null)) {
                        treePanel.tree.makeVisible(path); 
                        gui2.toFront();
                        index = 0;
                }
        }
        
        /** Listens to the radio buttons. */
        class RadioListener implements ActionListener { 
                public void actionPerformed(ActionEvent e) {
                        String action = e.getActionCommand();
                        if (action.equals("split") ) {
                                coverPanel.remove(centerPanel);
                                centerPanel2.add(middlePanelUp, BorderLayout.SOUTH);
                                if (((JCheckBoxMenuItem)viewMenu.getItem(0)).isSelected()) {             
                                        centerPanel2.add(treePanel, BorderLayout.CENTER);
                                }
                                else {
                                        centerPanel2.add(outputPanelUp, BorderLayout.CENTER);
                                } 
                                coverPanel.add(centerPanel2, BorderLayout.CENTER);                 
                                gui2.getContentPane().add(refinementPanel);
                                gui2.setVisible(true);
                                pack();
                                repaint();                                       
                        }
                        if (action.equals("combine") ) {
                                coverPanel.remove(centerPanel2);  
                                middlePanel.add(middlePanelUp, BorderLayout.NORTH);
                                if (((JCheckBoxMenuItem)viewMenu.getItem(0)).isSelected()) {                         gui2.setVisible(false);
                                centerPanel.setLeftComponent(treePanel);
                                }
                                else {
                                        centerPanel.setLeftComponent(outputPanelUp);
                                        gui2.setVisible(false);
                                } 
                                coverPanel.add(centerPanel, BorderLayout.CENTER);
                                centerPanelDown.add(refinementPanel, BorderLayout.CENTER);
                                pack();
                                repaint();               
                        }
                        
                        if (action.equals("showTree") ) {
                                if (!((JCheckBoxMenuItem)e.getSource()).isSelected()){
                                        if (debugXML) System.out.println("was selected");
                                        treeCbMenuItem.setSelected(false);
                                        if (((JRadioButtonMenuItem)viewMenu.getItem(2)).isSelected()) {      
                                                centerPanel.remove(treePanel);
                                                centerPanel.setLeftComponent(outputPanelUp); 
                                        }
                                        else {
                                                centerPanel2.remove(treePanel);
                                                centerPanel2.add(outputPanelUp, BorderLayout.CENTER); 
                                        }
                                }
                                else { 
                                        if (debugXML) System.out.println("was not selected");
                                        treeCbMenuItem.setSelected(true);
                                        if (((JRadioButtonMenuItem)viewMenu.getItem(2)).isSelected()) {      
                                                centerPanel.remove(outputPanelUp);
                                                treePanel.setRightComponent(outputPanelUp);
                                                centerPanel.setLeftComponent(treePanel);
                                        }
                                        else {
                                                centerPanel2.remove(outputPanelUp);
                                                treePanel.setRightComponent(outputPanelUp);
                                                centerPanel2.add(treePanel, BorderLayout.CENTER);
                                        }                    
                                }
                                pack();
                                repaint();                               
                        }
                        if (action.equals("lang")) {
                                if (newObject) {
                                        linearizationArea.setText("");
                                        formLin();
                                }
                                if (debugXML) 
                                        System.out.println("language option has changed "+((JCheckBoxMenuItem)e.getSource()).getText());
                                if (((JCheckBoxMenuItem)e.getSource()).isSelected()){
                                        if (debugXML) System.out.println("turning on");
                                        send("on "+((JCheckBoxMenuItem)e.getSource()).getText());
                                }
                                else{
                                        if (debugXML) System.out.println("turning off");
                                        send("off "+((JCheckBoxMenuItem)e.getSource()).getText());
                                }
                        }
                        //modeMenus actions:
                        else {
                                if ((action.equals("long")) || (action.equals("short")))  
                                {
                                        send("ms " + action);
                                }
                                else 
                                        if ((action.equals("typed")) || (action.equals("untyped")))  
                                        {
                                                send("mt " + action);
                                        }
                                        else 
                                        {
                                                selectedMenuLanguage = action;
                                                if (action.equals("Abstract"))
                                                {
                                                        send("ml Abs");
                                                }
                                                else 
                                                        if (!action.equals("split")&&!action.equals("combine")&&!action.equals("showTree"))
                                                        {
                                                                if (debugXML) System.out.println("sending "+action);
                                                                send("ml " + action);
                                                        }
                                        }
                        }
                }
        }
        
        /** Handle the key pressed event. */
        public void keyPressed(KeyEvent e) {
                int keyCode = e.getKeyCode();   
                Object obj = e.getSource();
                if  ((keyCode == 10)&&(obj==refinementList)) { 
                        listAction(refinementList.getSelectedIndex());
                }
                // Processing Enter:
                if  ((keyCode == 10)&&(obj==parseField)) { 
                        getLayeredPane().remove(parseField); 
                        treeChanged = true;
                        send("p "+parseField.getText());        
                        if (debugXML) System.out.println("sending parse string: "+parseField.getText());
                        repaint();
                }
                // Processing Escape:
                if  ((keyCode == 27)&&(obj==parseField)) { 
                        getLayeredPane().remove(parseField);   
                        repaint();
                }
                
        }
        /** Handle the key typed event. */
        public void keyTyped(KeyEvent e) {
        }
        /** Handle the key released event. */
        public void keyReleased(KeyEvent e) {
        }
        
        /** 
         * Returns the biggest position of first and second.
         * Each word in the linearization area has the corresponding
         * position in the tree. The position-notion is taken from 
         * GF-Haskell, where empty position ("[]") 
         * represents tree-root, "[0]" represents  first child of the root,
         * "[0,0]" represents the first grandchild of the root etc.
         * So comparePositions("[0]","[0,0]")="[0]"
         */
        protected String comparePositions(String first, String second)
        {
                String common ="[]";
                int i = 1; 
                while ((i<Math.min(first.length()-1,second.length()-1))&&(first.substring(0,i+1).equals(second.substring(0,i+1))))
                {
                        common=first.substring(0,i+1); 
                        i+=2;
                }
                if (common.charAt(common.length()-1)==']') 
                        return common;
                else 
                        return common+"]";
        }
        
        /**
         * Returns the widest position (see comments to comparePositions) 
         * covered in the string from begin to end in the 
         * linearization area
         * @param begin
         * @param end
         * @return the position in GF Haskell notation (hdaniels guesses)
         */
        protected String findMax(int begin, int end)
        {
                String max = (((MarkedArea)outputVector.elementAt(begin)).position).position;
                for (int i = begin+1; i <= end; i++)
                        max =  comparePositions(max,(((MarkedArea)outputVector.elementAt(i)).position).position);
                return max;
        }
        
        /**
         * One can either click on a leaf in the lin area, or select a larger subtree.
         * The corresponding tree node is selected.
         */
        public void caretUpdate(CaretEvent e)
        {
                String jPosition ="", iPosition="", position="";
                MarkedArea jElement = null;
                MarkedArea iElement = null;
                int j = 0;
                int i = outputVector.size()-1;
                int start = linearizationArea.getSelectionStart();
                int end = linearizationArea.getSelectionEnd();
                if (debugPopUp) 
                        System.out.println("SELECTION START POSITION: "+start);
                if (debugPopUp) 
                        System.out.println("SELECTION END POSITION: "+end);
                if (debugPopUp) 
                        System.out.println("CARET POSITION: "+linearizationArea.getCaretPosition());
                if ((debugLinMarking)&&(end>0&&(end<linearizationArea.getText().length()))) 
                        System.out.println("CHAR: "+linearizationArea.getText().charAt(end));
                // not null selection:
                if ((i>-1)&&(start<linearizationArea.getText().length()-1)) 
                {
                        if (debugLinMarking)
                                for (int k=0; k<outputVector.size(); k++)
                                { 
                                        System.out.print("element: "+k+" begin "+((MarkedArea)outputVector.elementAt(k)).begin+" ");
                                        System.out.print(" end: "+((MarkedArea)outputVector.elementAt(k)).end+" ");       
                                        System.out.print(" position: "+(((MarkedArea)outputVector.elementAt(k)).position).position+" ");   
                                        System.out.println(" words: "+((MarkedArea)outputVector.elementAt(k)).words);   
                                }
                        // localizing end:
                        while ((j< outputVector.size())&&(((MarkedArea)outputVector.elementAt(j)).end < end))
                                j++;
                        // localising start:
                        while ((i>=0)&&(((MarkedArea)outputVector.elementAt(i)).begin > start))
                                i--;
                        if (debugLinMarking) 
                                System.out.println("i: "+i+" j: "+j);
                        if ((j<outputVector.size()))
                        {
                                jElement = (MarkedArea)outputVector.elementAt(j);
                                jPosition = jElement.position.position;
                                // less & before:
                                if (i==-1)
                                { // less:
                                        if (end>=jElement.begin)
                                        {
                                                iElement = (MarkedArea)outputVector.elementAt(0);
                                                iPosition = iElement.position.position;
                                                if (debugLinMarking) 
                                                        System.out.println("Less: "+jPosition+" and "+iPosition);
                                                position = findMax(0,j);
                                                if (debugLinMarking) 
                                                        System.out.println("SELECTEDTEXT: "+position+"\n");
                                                treeChanged = true; 
                                                send("mp "+position);
                                        }
                                        // before:
                                        else 
                                                if (debugLinMarking) 
                                                        System.out.println("BEFORE vector of size: "+outputVector.size());
                                }
                                // just:
                                else
                                { 
                                        iElement = (MarkedArea)outputVector.elementAt(i);
                                        iPosition = iElement.position.position;
                                        if (debugLinMarking) 
                                                System.out.println("SELECTED TEXT Just: "+iPosition +" and "+jPosition+"\n");
                                        position = findMax(i,j);
                                        if (debugLinMarking) 
                                                System.out.println("SELECTEDTEXT: "+position+"\n");
                                        treeChanged = true; 
                                        send("mp "+position);
                                }
                        } 
                        else 
                                // more && after:
                                if (i>=0)
                                {
                                        iElement = (MarkedArea)outputVector.elementAt(i);
                                        iPosition = iElement.position.position;
                                        // more
                                        if (start<=iElement.end)
                                        { 
                                                jElement = (MarkedArea)outputVector.elementAt(outputVector.size()-1);
                                                jPosition = jElement.position.position;
                                                if (debugLinMarking) 
                                                        System.out.println("MORE: "+iPosition+ " and "+jPosition);
                                                position = findMax(i,outputVector.size()-1);
                                                if (debugLinMarking) 
                                                        System.out.println("SELECTEDTEXT: "+position+"\n");
                                                treeChanged = true; 
                                                send("mp "+position);
                                        }
                                        else
                                                // after:
                                                if (debugLinMarking) 
                                                        System.out.println("AFTER vector of size: "+outputVector.size());
                                } 
                                else
                                        // bigger:
                                {
                                        iElement = (MarkedArea)outputVector.elementAt(0);
                                        iPosition = iElement.position.position;
                                        jElement = (MarkedArea)outputVector.elementAt(outputVector.size()-1);
                                        jPosition = jElement.position.position;
                                        if (debugLinMarking) 
                                                System.out.println("BIGGER: "+iPosition +" and "+jPosition+"\n");         
                                        if (debugLinMarking) 
                                                System.out.println("SELECTEDTEXT: []\n");
                                        treeChanged = true; 
                                        send("mp []");
                                }
                }//not null selection
        }
        
        /**
         * Appends the string s to the text in the linearization area
         * on the screen.
         * (focus tag is already cut)
         * When selectionStart and selectionEnd are -1, then (most likely) no no selections are involved, nothing is registered
         * @param s string to append
         * @param selectionStart selection coordinate
         * @param selectionEnd selection coordinate
         * @param color the current color for the highlighted parts ((in-)correct type or not)
         */
        protected String appendMarked(String s, int selectionStart, int selectionEnd, Color color) {
                String appendedPureText = "";
                if (s.length()>0) {
                        if (debugLinMarking) {  
                                System.out.println("STRING: "+s);
                                System.out.println("where selection start is: "+selectionStart);
                                System.out.println("where selection end is: "+selectionEnd);
                                if ((selectionStart>-1)&&(selectionEnd>selectionStart))
                                        System.out.println("where selection is: "+s.substring(selectionStart,selectionEnd));
                        }
                        this.currentLength = 0;
                        this.newLength=0;
                        int oldLength = linearizationArea.getText().length();               
                        int j, l, l2, n, pos, selStartTotal, selEndTotal, selEndT;
                        this.restString = s;
                        int m2, m1;
                        LinPosition position ;
                        
                        if (selectionStart>-1) {
                                this.selStart = selectionStart;
                                this.selEnd = selectionEnd;                               
                                if (debugLinMarking) 
                                        System.out.println("SELECTION: " + this.selStart + " "+this.selEnd+ "TOTAL: "+s.length());
                                if (selEnd>selStart)
                                        selectionCheck = (getCharacter(s.substring(this.selStart, this.selEnd),"<",0)==-1);
                                l = this.restString.indexOf("<subtree");
                                l2 = this.restString.indexOf("</subtree");
                                // cutting subtree-tags:
                                while ((l2>-1)||(l>-1)) {           
                                        if ((l2==-1)||((l<l2)&&(l>-1))) {
                                                j = this.restString.indexOf('>',l);                                      
                                                n = getCharacter(this.restString,"<",j);
                                                m1 = this.restString.indexOf('[',l);
                                                m2 = this.restString.indexOf(']',l);
                                                //getting position:
                                                position = new LinPosition(this.restString.substring(m1,m2+1),
                                                                this.restString.substring(l,j).indexOf("incorrect")==-1);
                                                // something before the tag:
                                                if (l-currentLength>1) {
                                                        if (debugLinMarking) 
                                                                System.out.println("SOMETHING BEFORE THE TAG");
                                                        if (this.currentPosition.size()>0)
                                                                register(this.currentLength, l, (LinPosition)this.currentPosition.elementAt(this.currentPosition.size()-1));
                                                        else
                                                                register(this.currentLength, l, new LinPosition("[]",
                                                                                this.restString.substring(l,j).indexOf("incorrect")==-1));
                                                } else {       // nothing before the tag:
                                                        if (debugLinMarking) 
                                                                System.out.println("NOTHING BEFORE THE TAG");             
                                                        if (n>0)
                                                                register(j+2, n, position);
                                                        else
                                                                register(j+2, this.restString.length(), position);
                                                        removeSubTreeTag(l,j+1);
                                                }
                                                this.currentLength += this.newLength ;
                                        } else {// l<l2
                                                // something before the </subtree> tag:
                                                if (l2-currentLength>1) {
                                                        if (debugLinMarking) 
                                                                System.out.println("SOMETHING BEFORE THE </subtree> TAG");
                                                        if (this.currentPosition.size()>0)
                                                                register(this.currentLength, l2, (LinPosition)this.currentPosition.elementAt(this.currentPosition.size()-1));
                                                        else
                                                                register(this.currentLength, l2, new LinPosition("[]",
                                                                                this.restString.substring(l,l2).indexOf("incorrect")==-1));
                                                        this.currentLength += this.newLength ;
                                                }
                                                // nothing before the tag:
                                                else 
                                                        // punctuation after the </subtree> tag:
                                                        if (this.restString.substring(l2+10,l2+11).trim().length()>0)
                                                        {
                                                                if (debugLinMarking) 
                                                                        System.out.println("PUNCTUATION AFTER THE </subtree> TAG");
                                                                if (debugLinMarking) System.out.println("STRING: " + this.restString);
                                                                //cutting the tag first!:
                                                                if (l2>0)
                                                                        removeSubTreeTag(l2-1,l2+9); 
                                                                else
                                                                        removeSubTreeTag(l2,l2+9);
                                                                if (debugLinMarking) System.out.println("STRING after cutting the </subtree> tag: "+restString);
                                                                // cutting the space in the last registered component:
                                                                if (this.outputVector.size()>0)
                                                                {
                                                                        ((MarkedArea)this.outputVector.elementAt(this.outputVector.size()-1)).end -=1; 
                                                                        if (this.currentLength>0) {
                                                                                this.currentLength -=1; 
                                                                        }
                                                                }
                                                                if (debugLinMarking) System.out.println("currentLength: " + this.currentLength +" old length " + oldLength);
                                                                // register the punctuation:
                                                                if (this.currentPosition.size()>0)
                                                                        register(this.currentLength, this.currentLength+2, (LinPosition)this.currentPosition.elementAt(this.currentPosition.size()-1));
                                                                else
                                                                        register(this.currentLength, this.currentLength+2, new LinPosition("[]",
                                                                                        true));
                                                                this.currentLength += this.newLength ;
                                                        }
                                                        else
                                                                // just cutting the </subtree> tag:
                                                                removeSubTreeTag(l2,l2+10);
                                        }
                                        l2 = this.restString.indexOf("</subtree");
                                        l = this.restString.indexOf("<subtree");
                                        //          if (debug2) 
                                        //                System.out.println("/subtree index: "+l2 + "<subtree"+l);
                                        if (debugLinMarking) { 
                                                System.out.print("<-POSITION: "+l+" CURRLENGTH: "+this.currentLength);
                                                System.out.println(" STRING: "+this.restString.substring(this.currentLength));
                                        }
                                } //while
                                
                                if ((this.selEnd>=this.selStart)&&(this.outputVector.size()>0)) {
                                        // exclamation sign etc.:
                                        if (this.currentLength>this.selEnd)
                                                selStartTotal = this.selStart+oldLength;
                                        else
                                                selStartTotal = this.currentLength+oldLength;
                                        selEndTotal = this.selEnd+oldLength;
                                        selEndT = selEndTotal+1;
                                        pos = ((MarkedArea)this.outputVector.elementAt(this.outputVector.size()-1)).end;
                                        if (debugLinMarking) 
                                                System.out.print("the last registered position: "+ pos);
                                        if (debugLinMarking) 
                                                System.out.println(" selStart: "+ selStartTotal+ " selEnd: "+selEndTotal);
                                        if (this.selEnd+oldLength>pos)
                                        {
                                                this.addedLength = selEndTotal-selStartTotal+2;
                                                final MarkedArea maToAdd = new MarkedArea(selStartTotal, selEndTotal+1, this.focusPosition,this.restString.substring(this.currentLength));
                                                if (debugMarkedAreas && logger.isDebugEnabled()) {
                                                        logger.debug("MarkedArea  (A): " + maToAdd);
                                                }
                                                this.outputVector.addElement(maToAdd); 
                                                if (debugLinMarking) 
                                                        System.out.println("APPENDING Selection Last:"+this.restString.substring(this.currentLength)+
                                                                        "Length: "+this.addedLength+" POSITION: "+selStartTotal + " "+selEndT);
                                        }
                                }
                        } //if selectionStart>-1    
                        else
                        {
                                if (debugLinMarking) System.out.println("NO SELECTION IN THE TEXT TO BE APPENDED!");
                                //cutting tags from previous focuses if any:
                                int r = this.restString.indexOf("</subtree>");
                                while (r>-1)
                                {
                                        // check if punktualtion marks like . ! ? are at the end of a sentence:
                                        if (this.restString.charAt(r+10)==' ')
                                                this.restString = this.restString.substring(0,r)+this.restString.substring(r+11);
                                        else
                                                this.restString = this.restString.substring(0,r)+this.restString.substring(r+10);
                                        r = this.restString.indexOf("</subtree>");
                                }
                                r = this.restString.indexOf("<subtree");
                                while (r>-1)
                                {
                                        int t = getCharacter(this.restString,">",r);
                                        if (t<this.restString.length()-2)
                                                this.restString = this.restString.substring(0,r)+this.restString.substring(t+2);
                                        else 
                                                this.restString = this.restString.substring(0,r);
                                        r = this.restString.indexOf("<subtree");
                                }
                        }
                        // appending:
                        final String more = "\\"+">";
                        final String less = "\\"+"<";
                        final String newLine = "#";
                        //%% by daniels, linearization output will be changed drastically 
                        //(or probably will), so for now some hacks for -> and >=
                        this.restString = replaceSubstring(this.restString,"-" + more,"-> ");
                        this.restString = replaceSubstring(this.restString,more," >");
                        this.restString = replaceSubstring(this.restString,less," <");
                        this.restString = replaceSubstring(this.restString,newLine,"\n");
                        this.restString = replaceSubstring(this.restString,"(*)","\n\u2219 ");
                        this.restString= replaceSubstring(this.restString,"\\\\"," \\");
                        if (debugRed) 
                                System.out.println(this.restString);
                        appendedPureText = this.restString.replaceAll("&-","\n ");
                        linearizationArea.append(appendedPureText);
                        if ((selectionEnd>=selectionStart)&&(selectionStart>-1))
                                try {  
                                        linearizationArea.getHighlighter().addHighlight(this.selStart+oldLength, this.selEnd+oldLength+1, new DefaultHighlighter.DefaultHighlightPainter(color) );
                                        //here selectedText is set, remembered what is painted in green
                                        selectedText = linearizationArea.getText().substring(this.selStart+oldLength, this.selEnd+oldLength+1);
                                        // output.getHighlighter().addHighlight(selStart+oldLength, selEnd+oldLength+1, new DefaultHighlighter.DefaultHighlightPainter(Color.white) );
                                } catch (Exception e) {System.out.println("highlighting problem!");}
                }// s.length()>0
                return appendedPureText;
        }
        
        /**
         * Replaces the occurences of old by newString in the s
         * @param s
         * @param old
         * @param newString
         * @return the String with the aforementioned replacements
         */
        protected static String replaceSubstring(String s, String old, String newString) {
                String ss = s;
                int i =ss.indexOf(old);
                while (i!=-1)
                {
                        ss = ss.substring(0,i) + newString + ss.substring(i+old.length());
                        i =ss.indexOf(old);
                }
                return ss;
        }
        
        /**
         * Finding position of the charactern not starting with escape symbol (//) 
         * in the string s from position. 
         * @param s
         * @param character
         * @param position
         * @return
         */
        protected int getCharacter(String s, String character, int position)
        {
                int t = restString.indexOf(character, position);
                int i = t-1;
                int k = 0;
                while ((i>-1)&&(restString.charAt(i)=='\\'))
                {
                        k++;
                        i--;
                }
                if (k % 2 == 0)
                        return t;
                else
                        return getCharacter(s, character, t+1);
        }
        
        /**
         * Assigns the position to the substring from start to end in the linearization
         * @param start
         * @param end
         * @param position
         */
        protected void register(int start, int end, LinPosition position)
        {
                int oldLength = linearizationArea.getText().length();
                this.addedLength = 0;
                int resultCurrent = 0;
                int resultNew = 0;
                this.newLength = end-start;
                // the tag has some words to register:
                if (this.newLength>0)
                {
                        //focus has a separate position:
                        if (selectionCheck&&(end>selStart))
                        { 
                                selectionCheck=false;
                                if (debugLinMarking) 
                                        System.out.println("SELECTION HAS A SEPARATE POSITION"); 
                                if (debugLinMarking) 
                                        System.out.println("SELECTION: "+ this.selStart+" "+this.selEnd); 
                                if (debugLinMarking) 
                                        System.out.println("TEXT to REGISTER: "+ start+" "+end); 
                                if (debugLinMarking) 
                                        System.out.println("CURRLENGTH: "+ this.currentLength); 
                                
                                resultCurrent = this.currentLength+oldLength;
                                
                                if (this.selStart>start+1)
                                {
                                        // register text before selection:
                                        this.addedLength = this.selStart - start; 
                                        resultNew = resultCurrent+ this.addedLength -1;
                                        final MarkedArea maToAdd = new MarkedArea(resultCurrent, resultNew, position, this.restString.substring(start,start+this.addedLength));
                                        if (debugMarkedAreas && logger.isDebugEnabled()) {
                                                logger.debug("MarkedArea (R1) :" + maToAdd);
                                        }
                                        this.outputVector.addElement(maToAdd); 
                                        if (debugLinMarking) 
                                                System.out.println("APPENDING ZONE Before selection:"+this.restString.substring(start,start+this.addedLength)+
                                                                "Length: "+this.addedLength+" POSITION: "+resultCurrent + " "+resultNew);
                                } 
                                
                                //selection:
                                resultCurrent += this.addedLength;
                                this.addedLength = this.selEnd - this.selStart + 2;
                                resultNew = resultCurrent + this.addedLength - 1;
                                final MarkedArea maToAdd = new MarkedArea(resultCurrent, resultNew, this.focusPosition,this.restString.substring(this.selStart,this.selEnd+2));
                                if (debugMarkedAreas && logger.isDebugEnabled()) {
                                        logger.debug("MarkedArea (R2): " + maToAdd);
                                }
                                this.outputVector.addElement(maToAdd); 
                                if (debugLinMarking) 
                                        System.out.println("APPENDING SelectedZONE: "+this.restString.substring(this.selStart,this.selEnd+2)+
                                                        "Length: "+this.newLength+" POSITION: "+resultCurrent + " "+resultNew);            
                                
                                
                                if (end>this.selEnd+2)
                                {
                                        // register the rest:
                                        resultCurrent += this.addedLength;
                                        this.addedLength = end-this.selEnd-2;
                                        resultNew = resultCurrent + this.addedLength -1;
                                        final MarkedArea maToAdd2 = new MarkedArea(resultCurrent, resultNew, position,this.restString.substring(this.selEnd+2,end));
                                        if (debugMarkedAreas && logger.isDebugEnabled()) {
                                                logger.debug("MarkedArea (R3): " + maToAdd);
                                        }
                                        this.outputVector.addElement(maToAdd2); 
                                        if (debugLinMarking) 
                                                System.out.println("APPENDING ZONE after:"+
                                                                this.restString.substring(this.selEnd+2,end)+
                                                                "Length: "+this.newLength+" POSITION: "+resultCurrent + " "+resultNew);
                                }
                        }// focus has a separate position
                        else 
                        {
                                resultCurrent = this.currentLength + oldLength ;
                                resultNew = this.newLength + resultCurrent - 1;
                                if (debugLinMarking) System.out.println("Start: "+ start + " end: "+end);
                                if (debugLinMarking) System.out.println("STRING: "+ this.restString + " which length is: "+this.restString.length());
                                String stringToAppend = this.restString.substring(start,end);
                                if (stringToAppend.trim().length()>0) {
                                        final MarkedArea maToAdd = new MarkedArea(resultCurrent, resultNew, position,stringToAppend);
                                        if (debugMarkedAreas && logger.isDebugEnabled()) {
                                                logger.debug("MarkedArea (R4): " + maToAdd);
                                        }
                                        this.outputVector.addElement(maToAdd); 
                                        if (debugLinMarking) 
                                                System.out.println("APPENDING ZONE:"+stringToAppend+
                                                                "Length: "+this.newLength+" POSITION: "+resultCurrent + " "+resultNew+" "+position.position);
                                }
                                else
                                        if (debugLinMarking) 
                                                System.out.println("whiteSpaces: "+this.newLength);
                        } 
                } //some words to register                     
        }
        
        /**
         * removing subtree-tag in the interval start-end 
         * and updating the coordinates after that
         * basically part of appendMarked
         * No subtree is removed, just the tag. 
         * @param start position in restString
         * @param end position in restString
         */
        protected void removeSubTreeTag (int start, int end)
        {
                if (debugLinMarking) 
                        System.out.println("removing: "+ start +" to "+ end);
                int difference =end-start+1;
                int positionStart, positionEnd;
                if (difference>20)
                {
                        positionStart = restString.indexOf("[", start);
                        positionEnd = restString.indexOf("]", start);
                        
                        currentPosition.addElement(new LinPosition(
                                        restString.substring(positionStart, positionEnd+1),
                                        restString.substring(start,end).indexOf("incorrect")==-1));
                }
                else
                        if (currentPosition.size()>0)
                                currentPosition.removeElementAt(currentPosition.size()-1); 
                if (start>0)
                        restString = restString.substring(0,start)+restString.substring(end+1);
                else
                        restString = restString.substring(end+1);
                if (selStart > end) {
                        selStart -=difference;
                        selEnd -=difference;            
                } 
                else 
                        if (selEnd < start) ;
                        else selEnd -=difference;            
        }
        
        /**
         * handling the event of choosing the action at index from the list
         * @param index
         */
        protected void listAction(int index) {
                if (index == -1) 
                {if (debugXML) System.out.println("no selection");}
                else {
                        treeChanged = true; 
                        send((String)commands.elementAt(refinementList.getSelectedIndex()));
                }
        }
        
        /**
         * pop-up menu (adapted from DynamicTree2):
         * @author janna
         *
         */ 
        class PopupListener extends MouseAdapter {
                public void mousePressed(MouseEvent e) {
                        //            int selStart = tree.getRowForLocation(e.getX(), e.getY());
                        //            output.setSelectionRow(selStart);
                        if (debugPopUp) 
                                System.out.println("mouse pressed2: "+linearizationArea.getSelectionStart()+" "+linearizationArea.getSelectionEnd());
                        //maybeShowPopup(e);
                }
                
                public void mouseReleased(MouseEvent e) {
                        if (debugPopUp) System.out.println("mouse released2!"+linearizationArea.getSelectionStart()+" "+linearizationArea.getSelectionEnd());
                        maybeShowPopup(e);
                }
        }
        void maybeShowPopup(MouseEvent e) {
                //int i=outputVector.size()-1;
                // right click:
                if (e.isPopupTrigger()) {
                        mouseEvent2 = e;
                        timer2.start();
                } 
                // middle click    
                if (e.getButton() == MouseEvent.BUTTON2) 
                {
                        // selection Exists:
                        if (!selectedText.equals(""))
                        {
                                if (debugPopUp) System.out.println(e.getX() + " " + e.getY());
                                if (selectedText.length()<5)
                                        if (treeCbMenuItem.isSelected())
                                                parseField.setBounds(e.getX()+(int)Math.round(tree.getBounds().getWidth()), e.getY()+80, 400, 40);
                                        else
                                                parseField.setBounds(e.getX(), e.getY()+80, 400, 40); 
                                else
                                        if (treeCbMenuItem.isSelected())
                                                parseField.setBounds(e.getX()+(int)Math.round(tree.getBounds().getWidth()), e.getY()+80, selectedText.length()*20, 40);
                                        else
                                                parseField.setBounds(e.getX(), e.getY()+80, selectedText.length()*20, 40);
                                getLayeredPane().add(parseField, new Integer(1), 0);  
                                parseField.setText(selectedText);
                                parseField.requestFocusInWindow();
                        }
                }
        }

        /**
         * for copying the select menu into a popup menu
         * @param name The actual GF command
         */
        void addMenuItem(String name){
                JMenuItem menuItem2 = new JMenuItem(name);
                menuItem2.setFont(font);
                menuItem2.setActionCommand("popupMenuItem");
                menuItem2.addActionListener(this);
                popup2.add(menuItem2);
                
        }
        public void focusGained(FocusEvent e) 
        {
        }
        public void focusLost(FocusEvent e) 
        {
                getLayeredPane().remove(parseField);
                repaint();
        }
}
