// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

package de.uka.ilkd.key.ocl.ocldltranslator.test;
import de.uka.ilkd.key.ocl.ocldltranslator.*;
import java.io.*;

import java.io.IOException;

public class TestFacade extends ProverFacadeImpl {

    private static final String JAVA_SOURCE_SUFFIX = ".java";


    /**
     * Initializes the Facade to read the source files of a correpsonding
     * implementation of the given UML model.
     * @param implementationSources -- the directory containing the source files
     */     
    public TestFacade(String implementationSources) throws IOException{
	super(getClassesInPackage(implementationSources));
    }

    /**
     * @return an array with the absolute path names of all files '*.java' in
     * the given directory.
     */
    private static String[] getClassesInPackage(String dirPath) {
	String[] result = null;
    
	File dirFile = new File(dirPath);
	
	File[] sourceFiles = dirFile.listFiles(new FilenameFilter(){
		public boolean accept(File dir, String name){
		    return (name.endsWith(JAVA_SOURCE_SUFFIX));
		}
	    });
	
	if (sourceFiles != null){
	    result = new String[sourceFiles.length];
	    for(int i = 0; i < sourceFiles.length; i++){
		result[i] = sourceFiles[i].getAbsolutePath();
	    }
	}

	return result;
    }



}




