// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//
package de.uka.ilkd.key.ocl.ocldltranslator.transform;

import java.util.*;
import de.uka.ilkd.key.logic.*;

import de.uka.ilkd.key.ocl.ocldltranslator.*;
import de.uka.ilkd.key.ocl.ocldltranslator.heuristics.*;
import de.uka.ilkd.key.ocl.ocldltranslator.control.*;
import de.uka.ilkd.key.ocl.ocldltranslator.normalize.*;

/** 
 * Only for use in the generation of the translation of an OCL constaint !!!
 *
 * Interface for classes handling occurences of @pre-tagged
 * function symbols in the formulas that have been generated during the 
 * translation of of a pre/post-constraint.
 */ 
 
public interface AtPreTransformer  {
    
    /**
     * Starts the transformation of @pre-tagged function symbols in the pre- and post-translation.
     * @param preTranslation - the translation of the pre-Part of the constraint.
     * @param postTranslation - the translation of the post-Part of the constraint.
     */

    void transformAtPre(TranslationResult preTranslation, 
			TranslationResult postTranslation);
    

    
}
