// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//
package de.uka.ilkd.key.proof.init;

import de.uka.ilkd.key.util.Debug;
import de.uka.ilkd.key.java.Recoder2KeY;
import de.uka.ilkd.key.casetool.*;
import java.io.*;

public class CasetoolDLPO extends KeYUserProblemFile {

    private ReprModelClass aClRepr;

    public CasetoolDLPO(ReprModelClass reprModelCl, java.io.File file) {
	super(file.getName(), file, null);
	this.aClRepr=reprModelCl;
    }


    public String readJava() {
	if (initConfig==null) {
	    throw new IllegalStateException("KeYFile: InitConfig not set.");
	}
	Recoder2KeY r2k = new Recoder2KeY(initConfig.getServices(),
					  initConfig.namespaces());
	String[] cus = aClRepr.getClassesInPackage();
	r2k.readCompilationUnitsAsFiles(cus);
        return aClRepr.getRootDirectory();
    }


}
