// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//
package de.uka.ilkd.key.proof.init;

import de.uka.ilkd.key.java.Recoder2KeY;
import de.uka.ilkd.key.casetool.*;
import de.uka.ilkd.key.proof.mgt.Contract;


/** represents an OCL invariant proof obligation as input to the prover.
 */
public abstract class OCLInvPO extends OCLProofOblInput {

    protected String xmifile;
    protected ReprModelClass modelClass;
    protected ModelManager modMan;

    /** creates a new OCL invariant proof obligation having a given name,
     * a xmifile to read the model from, and a representation of a 
     * model class where the OCL proof obligation has been initiated.
     */
    public OCLInvPO(String name, 
		    String xmifile, ReprModelClass aClRepr) {
	super(name);
	this.xmifile=xmifile;
	this.modelClass=aClRepr;
    }


    public ReprModelClass getModelClass() {
	return modelClass;
    }

    public Object getObjectOfContract() {
	return getModelClass();
    }

    public boolean fitsToContract(Contract ct) {
	return false; //%%
    }


}
