// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

package de.uka.ilkd.key.proof.mgt;

import de.uka.ilkd.key.casetool.ReprModelMethod;
import de.uka.ilkd.key.rule.Taclet;
import de.uka.ilkd.key.logic.op.Modality;


public abstract class AbstractMethodContract extends AbstractContract
                                             implements MethodContract {

    protected ReprModelMethod meth;
    protected Taclet lemma;
    protected Modality modality;


    protected AbstractMethodContract(ReprModelMethod meth) {
	this.meth = meth;
    }

    protected AbstractMethodContract() {
    }

    protected abstract AbstractMethodLemmaFactory getMethodLemmaFactory();

    public Taclet getLemmaAndRegister() {
	if (lemma==null && modality==de.uka.ilkd.key.logic.op.Op.DIA) {
	    AbstractMethodLemmaFactory ms = getMethodLemmaFactory();
	    lemma=ms.getTaclet();
	    if (lemma!=null) {
		env.registerRule(lemma, new RuleJustificationByMethodSpec(this));
	    } 
	}
	return lemma;
    }

    public ReprModelMethod getModelMethod() {
	return meth;
    }

    public Modality getModality() {
	return modality;
    }

    public Object getObjectOfContract() {
	return getModelMethod();
    }


}
