// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

package de.uka.ilkd.key.proof.mgt;

import de.uka.ilkd.key.proof.ProofList;
import de.uka.ilkd.key.rule.Taclet;
import de.uka.ilkd.key.proof.init.ProofOblInput;
import java.util.List;

public interface Contract {

    void addProofList(ProofList pl);

    void removeProofList(ProofList pl);

    List getProofs();

    Object getObjectOfContract();

    void setProofEnv(ProofEnvironment env);

    ProofEnvironment getProofEnv();

    ProofOblInput getProofOblInput();

    Taclet getLemmaAndRegister();


}
