// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2004 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
package de.uka.ilkd.key.proof.mgt;

import de.uka.ilkd.key.rule.*;
import java.util.*;

public class RuleJustificationInfo {

    private Map rule2justif = new HashMap();

    public void addJustification(Rule r, RuleJustification j) {
	rule2justif.put(r, j);
    }

    public void addJustification(RuleApp r, RuleJustification j) {
	//	rule2justif.put(r, j);  //%% hack implement hashcode of ruleapp!
	rule2justif.put(r.rule(), j);
    }

    public RuleJustification getJustification(Rule r) {
	return (RuleJustification) rule2justif.get(r);
    }

    public RuleJustification getJustification(RuleApp r) {
	RuleJustification just = getJustification(r.rule());
	if (just!=null) {
	    return just;
	} // %% never reached, need implementation of hashcode in rule code
	// then: build NoPosRuleApp from PosRuleApp and lookup
	return (RuleJustification) rule2justif.get(r);
    }


}
