// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

package de.uka.ilkd.key.rule.metaconstruct;


import de.uka.ilkd.key.java.Expression;
import de.uka.ilkd.key.java.reference.TypeRef;
import de.uka.ilkd.key.logic.sort.Sort;
import de.uka.ilkd.key.logic.Name;
import de.uka.ilkd.key.logic.Term;
import de.uka.ilkd.key.rule.inst.SVInstantiations;
import de.uka.ilkd.key.logic.op.ExpressionOperator;
import de.uka.ilkd.key.logic.op.SchemaVariable;
import de.uka.ilkd.key.logic.op.Op;
import de.uka.ilkd.key.logic.TermFactory;

public class IsObject extends IsCertainReference {

    private static final Name typeof_name = new Name("#isObject");

    public IsObject(Sort sort, Expression expr) {
	super(typeof_name, 
	      new String[]{"Object", "java.lang.Object"}, 
	      sort, expr);
    }
}
