// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

package de.uka.ilkd.key.rule.soundness;

import de.uka.ilkd.key.rule.*;
import de.uka.ilkd.key.rule.inst.*;
import de.uka.ilkd.key.logic.*;
import de.uka.ilkd.key.logic.op.IProgramVariable;
import de.uka.ilkd.key.logic.op.SchemaVariable;
import de.uka.ilkd.key.logic.op.ListOfIProgramVariable;
import de.uka.ilkd.key.logic.op.SLListOfIProgramVariable;
import de.uka.ilkd.key.logic.op.Modality;
import de.uka.ilkd.key.proof.Goal;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Stack;
import de.uka.ilkd.key.java.*;
import de.uka.ilkd.key.java.declaration.LocalVariableDeclaration;
import de.uka.ilkd.key.java.declaration.VariableSpecification;
import de.uka.ilkd.key.java.abstraction.Type;
import de.uka.ilkd.key.java.abstraction.KeYJavaType;
import de.uka.ilkd.key.java.abstraction.ArrayOfKeYJavaType;
import de.uka.ilkd.key.java.abstraction.PrimitiveType;
import de.uka.ilkd.key.java.statement.*;
import de.uka.ilkd.key.java.expression.*;
import de.uka.ilkd.key.java.expression.operator.*;
import de.uka.ilkd.key.util.ExtList;


public class StaticProgramCheckerSVI extends StaticProgramChecker {

    private SVInstantiations svi;

    public StaticProgramCheckerSVI ( ProgramElement   p_root,
				     SVInstantiations p_svi,
				     Services         p_services ) {
	super ( p_root, p_services );
	svi = p_svi;
    }


    public SVInstantiations getSVInstantiations () {
	return svi;
    }


    public void doSchemaVariable(SchemaVariable x)     {
	// todo: handle some special sv sorts, whose type is
	// determined without instantiation
	if ( getSVInstantiations ().isInstantiated ( x ) ) {
	    walk ( (ProgramElement)getSVInstantiations ()
		   .getInstantiation ( x ) );
	} else
	    pushUnknown ();
    }

}
