// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
/*
 * Created on 15.12.2004
 */
package de.uka.ilkd.key.rule.updatesimplifier;

import de.uka.ilkd.key.logic.Term;
import de.uka.ilkd.key.logic.op.AnonymousUpdate;
import de.uka.ilkd.key.logic.op.NonRigid;
import de.uka.ilkd.key.logic.op.Operator;
import de.uka.ilkd.key.rule.AbstractUpdateRule;
import de.uka.ilkd.key.rule.UpdateSimplifier;

/**
 * @author bubel
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ApplyAnonymousUpdateOnNonRigid extends AbstractUpdateRule {

    /**
     * @param updateSimplifier
     */
    public ApplyAnonymousUpdateOnNonRigid(UpdateSimplifier updateSimplifier) {
        super(updateSimplifier);      
    }

    /* (non-Javadoc)
     * @see de.uka.ilkd.key.rule.UpdateRule#isApplicable(de.uka.ilkd.key.rule.updatesimplifier.Update, de.uka.ilkd.key.logic.Term)
     */
    public boolean isApplicable(Update update, Term target) {        
        final Operator op = target.op();
        return update.isAnonymousUpdate() && 
           target.op() instanceof NonRigid && 
           !(target.op() instanceof AnonymousUpdate);
    }

    /* (non-Javadoc)
     * @see de.uka.ilkd.key.rule.UpdateRule#apply(de.uka.ilkd.key.rule.updatesimplifier.Update, de.uka.ilkd.key.logic.Term)
     */
    public Term apply(Update update, Term target) {
        // use update simplifier termfactory in particular to be sure to create correct 
        // anonymous updates
        logEnter(update, target);
        Term simplifiedTarget = updateSimplifier().simplify(target);
        Term result = UpdateSimplifierTermFactory.DEFAULT.
           createUpdateTerm(update.getAllAssignmentPairs(), simplifiedTarget);
        logExit(result);
        return result;
    }

}
