// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
/*
 * Created on 18.12.2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package de.uka.ilkd.key.rule.updatesimplifier;

import de.uka.ilkd.key.logic.Term;
import de.uka.ilkd.key.logic.TermFactory;
import de.uka.ilkd.key.logic.op.ConjCond;
import de.uka.ilkd.key.logic.op.IfElse;
import de.uka.ilkd.key.rule.AbstractUpdateRule;
import de.uka.ilkd.key.rule.UpdateSimplifier;

/**
 * @author bubel
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ApplyOnConditionalTerm extends AbstractUpdateRule {

    /**
     * @param simplifier
     */
    public ApplyOnConditionalTerm(UpdateSimplifier simplifier) {        
        super(simplifier);
    }

    /**
     * tests if the rule is applicable 
     * @see de.uka.ilkd.key.rule.IUpdateRule#isApplicable(de.uka.ilkd.key.rule.updatesimplifier.Update, de.uka.ilkd.key.logic.Term)
     */
    public boolean isApplicable(Update update, Term target) {        
        return target.op() instanceof IfElse;
    }

    /**
     * applies the given update on the target term whose top operator has to be
     * a conditional operator 
     * @see de.uka.ilkd.key.rule.IUpdateRule#apply(de.uka.ilkd.key.rule.updatesimplifier.Update, de.uka.ilkd.key.logic.Term)
     */
    public Term apply(Update update, Term target) {
        logEnter(update, target);
        
        Term result = target;
        PropagationResult pr = propagateUpdateToSubterms(update, target);
        if (pr.hasChanged()) {
            result = createConditionalTermAndSimplify((IfElse)target.op(),
                        pr.getSimplifiedSubterms());
        }
        
        logExit(result);        
        return result;
    }

    /**
     * decides according to the given operator which kind of conditional term 
     * has to be created and simplified as far as possible
     * @param op the IfElse operator
     * @param subs the sub terms of the conditional to be created and simplified
     * @return a simplified conditional term
     */
    private Term createConditionalTermAndSimplify(IfElse op, Term[] subs) {
        if (op instanceof ConjCond) {
            return TermFactory.DEFAULT.
             createConjConditionalTermAndSimplify(subs);
        } else {                      
            return TermFactory.DEFAULT.createIfElseTermAndSimplify(subs);
        }
    }
}
